import { InjectionToken, Injectable, Inject, EventEmitter, Component, ComponentFactoryResolver, Input, Output, ViewChild, ViewContainerRef, ViewEncapsulation, ChangeDetectionStrategy, HostListener, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { __extends, __assign, __spread, __decorate, __metadata, __read } from 'tslib';
import { NodeService, TreeActionTypes, NodeDispatcherService, TreeInitializerService, TreeComponent, TreeModule } from '@rign/angular2-tree';
import { HttpClient, HttpParams, HttpClientModule } from '@angular/common/http';
import { CropperSettings } from 'ng2-img-cropper/src/cropperSettings';
import { ImageCropperComponent, ImageCropperModule } from 'ng2-img-cropper';
import { Store, createFeatureSelector, StoreModule } from '@ngrx/store';
import { FileUploader, FileUploadModule } from 'ng2-file-upload';
import { UUID } from 'angular2-uuid';
import { concatMap, map, distinctUntilChanged, withLatestFrom, switchMap, catchError, filter, debounceTime } from 'rxjs/operators';
import { of, fromEvent, Subject, BehaviorSubject, combineLatest, empty, throwError, Observable, Subscription } from 'rxjs';
import { ofType, Actions, Effect, EffectsModule } from '@ngrx/effects';
import { FormControl, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { ConfirmationPopoverModule } from 'angular-confirmation-popover';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var FILEMANAGER_TRANSLATION_TOKEN = new InjectionToken('[Filemanager] Fielmanager translation service');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileManagerConfiguration = /** @class */ (function () {
    function FileManagerConfiguration(configuration, filemanagerTranslations) {
        this.filemanagerTranslations = filemanagerTranslations;
        this.allowedCropSize = [
            {
                name: this.filemanagerTranslations.RI_FM_BTN_LANDSCAPE,
                width: 300,
                height: 100
            },
            {
                name: this.filemanagerTranslations.RI_FM_BTN_PORTRAIT,
                width: 200,
                height: 300
            }
        ];
        this.contextMenuItems = [];
        this.fileTypesFilter = [
            {
                name: 'ALL',
                mimes: [],
                iconCls: 'fa fa-file-o',
                text: 'All files',
                defaultSelected: true
            },
            {
                name: 'IMAGES',
                mimes: ['image/jpg', 'image/jpeg', 'image/png', 'image/gif', 'image/png'],
                iconCls: 'fa fa-picture-o',
                text: 'Images'
            },
            {
                name: 'AUDIO',
                mimes: ['audio/mpeg', 'audio/x-ms-wma', 'audio/vnd.rn-realaudio', 'audio/x-wav', 'audio/mp3'],
                iconCls: 'fa fa-file-audio-o',
                text: 'Audio'
            },
            {
                name: 'VIDEO',
                mimes: ['video/mpeg', 'video/mp4', 'video/quicktime', 'video/x-ms-wmv'],
                iconCls: 'fa fa-file-video-o',
                text: 'Video'
            },
            {
                name: 'ARCHIVE',
                mimes: ['application/zip'],
                iconCls: 'fa fa-file-archive-o',
                text: 'Archive'
            }
        ];
        this.fileUrl = '/api/files';
        var _a = configuration.urls, foldersUrl = _a.foldersUrl, folderMoveUrl = _a.folderMoveUrl;
        this.folderUrls = { foldersUrl: foldersUrl, folderMoveUrl: folderMoveUrl };
        this.fileUrl = configuration.urls.filesUrl;
        this.isMultiSelection = configuration.isMultiSelection || false;
        this.maxFileSize = configuration.maxFileSize || 0;
        this.mimeTypes = configuration.mimeTypes || null;
        this.allowChooseMultipleFiles = configuration.allowChooseMultipleFiles || false;
    }
    FileManagerConfiguration.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    FileManagerConfiguration.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: ['fileManagerConfiguration',] }] },
        { type: undefined, decorators: [{ type: Inject, args: [FILEMANAGER_TRANSLATION_TOKEN,] }] }
    ]; };
    return FileManagerConfiguration;
}());
if (false) {
    /** @type {?} */
    FileManagerConfiguration.prototype.allowedCropSize;
    /** @type {?} */
    FileManagerConfiguration.prototype.contextMenuItems;
    /** @type {?} */
    FileManagerConfiguration.prototype.fileTypesFilter;
    /** @type {?} */
    FileManagerConfiguration.prototype.folderUrls;
    /** @type {?} */
    FileManagerConfiguration.prototype.fileUrl;
    /** @type {?} */
    FileManagerConfiguration.prototype.isMultiSelection;
    /** @type {?} */
    FileManagerConfiguration.prototype.maxFileSize;
    /** @type {?} */
    FileManagerConfiguration.prototype.mimeTypes;
    /** @type {?} */
    FileManagerConfiguration.prototype.allowChooseMultipleFiles;
    /** @type {?} */
    FileManagerConfiguration.prototype.filemanagerTranslations;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IFileManagerConfiguration() { }
if (false) {
    /** @type {?} */
    IFileManagerConfiguration.prototype.urls;
    /** @type {?|undefined} */
    IFileManagerConfiguration.prototype.isMultiSelection;
    /** @type {?|undefined} */
    IFileManagerConfiguration.prototype.maxFileSize;
    /** @type {?|undefined} */
    IFileManagerConfiguration.prototype.mimeTypes;
    /** @type {?} */
    IFileManagerConfiguration.prototype.allowChooseMultipleFiles;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var IUrlConfiguration = /** @class */ (function () {
    function IUrlConfiguration() {
    }
    return IUrlConfiguration;
}());
if (false) {
    /** @type {?} */
    IUrlConfiguration.prototype.filesUrl;
    /** @type {?} */
    IUrlConfiguration.prototype.foldersUrl;
    /** @type {?} */
    IUrlConfiguration.prototype.folderMoveUrl;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TreeService = /** @class */ (function (_super) {
    __extends(TreeService, _super);
    function TreeService(http, configuration) {
        var _this = _super.call(this, http) || this;
        _this.http = http;
        _this.apiConfig = {
            addUrl: configuration.urls.foldersUrl,
            getUrl: configuration.urls.foldersUrl,
            updateUrl: configuration.urls.foldersUrl,
            removeUrl: configuration.urls.foldersUrl,
            moveUrl: configuration.urls.folderMoveUrl
        };
        return _this;
    }
    TreeService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    TreeService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: undefined, decorators: [{ type: Inject, args: ['fileManagerConfiguration',] }] }
    ]; };
    return TreeService;
}(NodeService));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    TreeService.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileModel = /** @class */ (function () {
    function FileModel(data) {
        this._iconsFolder = FileModel.smallIconsFolder;
        this.selected = false;
        this.fromJSON(data);
    }
    Object.defineProperty(FileModel.prototype, "name", {
        get: /**
         * @return {?}
         */
        function () {
            return this._name;
        },
        set: /**
         * @param {?} name
         * @return {?}
         */
        function (name) {
            this._name = name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileModel.prototype, "thumbnailUrl", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isImage() ? this._orgData.thumbnailUrl : "" + FileModel.smallIconsFolder + this.getFileExt() + ".png";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FileModel.prototype, "url", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isImage() ? this._orgData.url : "" + FileModel.bigIconsFolder + this.getFileExt() + ".png";
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} data
     * @return {?}
     */
    FileModel.prototype.fromJSON = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this._orgData = data;
        this.name = data.name;
        this.selected = data.selected || false;
    };
    /**
     * @return {?}
     */
    FileModel.prototype.toJSON = /**
     * @return {?}
     */
    function () {
        return this._orgData;
    };
    /**
     * @return {?}
     */
    FileModel.prototype.getId = /**
     * @return {?}
     */
    function () {
        return this._orgData.id;
    };
    /**
     * @return {?}
     */
    FileModel.prototype.getHeight = /**
     * @return {?}
     */
    function () {
        return this._orgData.height || 0;
    };
    /**
     * @return {?}
     */
    FileModel.prototype.getFileExt = /**
     * @return {?}
     */
    function () {
        return this.name.split('.').pop();
    };
    /**
     * @return {?}
     */
    FileModel.prototype.getMime = /**
     * @return {?}
     */
    function () {
        return this._orgData.type;
    };
    /**
     * @return {?}
     */
    FileModel.prototype.getWidth = /**
     * @return {?}
     */
    function () {
        return this._orgData.width || 0;
    };
    /**
     * @return {?}
     */
    FileModel.prototype.isImage = /**
     * @return {?}
     */
    function () {
        return ['image/jpg', 'image/jpeg', 'image/png', 'image/gif', 'image/png'].indexOf(this.getMime()) > -1;
    };
    /**
     * @return {?}
     */
    FileModel.prototype.getSelectData = /**
     * @return {?}
     */
    function () {
        return {
            id: this.getId(),
            name: this.name,
            url: this.url,
            width: this.getWidth(),
            height: this.getHeight(),
            mime: this.getMime()
        };
    };
    FileModel.smallIconsFolder = '/icons/128px/';
    FileModel.bigIconsFolder = '/icons/512px/';
    return FileModel;
}());
if (false) {
    /** @type {?} */
    FileModel.smallIconsFolder;
    /** @type {?} */
    FileModel.bigIconsFolder;
    /**
     * @type {?}
     * @private
     */
    FileModel.prototype._orgData;
    /**
     * @type {?}
     * @private
     */
    FileModel.prototype._name;
    /**
     * @type {?}
     * @private
     */
    FileModel.prototype._iconsFolder;
    /** @type {?} */
    FileModel.prototype.selected;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var FileManagerActionTypes = {
    CHOOSE_FILES: 'FILEMANAGER_CHOOSE_FILES',
    CROP_FILE: 'FILEMANAGER_CROP_FILE',
    CROP_FILE_SUCCESS: 'FILEMANAGER_CROP_FILE_SUCCESS',
    CROP_FILE_ERROR: 'FILEMANAGER_CROP_FILE_ERROR',
    DELETE_FILE: 'FILEMANAGER_DELETE_FILE',
    DELETE_FILE_SUCCESS: 'FILEMANAGER_DELETE_FILE_SUCCESS',
    DELETE_FILE_SELECTION: 'FILEMANAGER_DELETE_FILE_SELECTION',
    DELETE_FILE_SELECTION_SUCCESS: 'FILEMANAGER_DELETE_FILE_SELECTION_SUCCESS',
    INVERSE_FILE_SELECTION: 'FILEMANAGER_INVERSE_FILE_SELECTION',
    LOAD_FILES: 'FILEMANAGER_LOAD_FILES',
    LOAD_FILES_SUCCESS: 'FILEMANAGER_LOAD_FILES_SUCCESS',
    MOVE_FILES_SUCCESS: 'FILEMANAGER_MOVE_FILES_SUCCESS',
    MOVE_FILES_ERROR: 'FILEMANAGER_MOVE_FILES_ERROR',
    SELECT_ALL: 'FILEMANAGER_SELECT_ALL',
    SELECT_FILE: 'FILEMANAGER_SELECT_FILE',
    UNSELECT_FILE: 'FILEMANAGER_UNSELECT_FILE',
    UNSELECT_ALL: 'FILEMANAGER_UNSELECT_ALL',
    UPLOAD_FILE: 'FILEMANAGER_UPLOAD_FILE',
    UPLOAD_FILE_ERROR: 'FILEMANAGER_UPLOAD_FILE_ERROR',
    UPLOAD_FILE_SUCCESS: 'FILEMANAGER_UPLOAD_FILE_SUCCESS',
};
var ChooseFilesAction = /** @class */ (function () {
    function ChooseFilesAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.CHOOSE_FILES;
    }
    return ChooseFilesAction;
}());
if (false) {
    /** @type {?} */
    ChooseFilesAction.prototype.type;
    /** @type {?} */
    ChooseFilesAction.prototype.payload;
}
var CropFileAction = /** @class */ (function () {
    function CropFileAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.CROP_FILE;
    }
    return CropFileAction;
}());
if (false) {
    /** @type {?} */
    CropFileAction.prototype.type;
    /** @type {?} */
    CropFileAction.prototype.payload;
}
var CropFileErrorAction = /** @class */ (function () {
    function CropFileErrorAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.CROP_FILE_ERROR;
    }
    return CropFileErrorAction;
}());
if (false) {
    /** @type {?} */
    CropFileErrorAction.prototype.type;
    /** @type {?} */
    CropFileErrorAction.prototype.payload;
}
var CropFileSuccessAction = /** @class */ (function () {
    function CropFileSuccessAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.CROP_FILE_SUCCESS;
    }
    return CropFileSuccessAction;
}());
if (false) {
    /** @type {?} */
    CropFileSuccessAction.prototype.type;
    /** @type {?} */
    CropFileSuccessAction.prototype.payload;
}
var DeleteFileAction = /** @class */ (function () {
    function DeleteFileAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.DELETE_FILE;
    }
    return DeleteFileAction;
}());
if (false) {
    /** @type {?} */
    DeleteFileAction.prototype.type;
    /** @type {?} */
    DeleteFileAction.prototype.payload;
}
var DeleteFileSuccessAction = /** @class */ (function () {
    function DeleteFileSuccessAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.DELETE_FILE_SUCCESS;
    }
    return DeleteFileSuccessAction;
}());
if (false) {
    /** @type {?} */
    DeleteFileSuccessAction.prototype.type;
    /** @type {?} */
    DeleteFileSuccessAction.prototype.payload;
}
var DeleteSelectedFilesAction = /** @class */ (function () {
    function DeleteSelectedFilesAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.DELETE_FILE_SELECTION;
    }
    return DeleteSelectedFilesAction;
}());
if (false) {
    /** @type {?} */
    DeleteSelectedFilesAction.prototype.type;
    /** @type {?} */
    DeleteSelectedFilesAction.prototype.payload;
}
var DeleteSelectedFilesSuccessAction = /** @class */ (function () {
    function DeleteSelectedFilesSuccessAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.DELETE_FILE_SELECTION_SUCCESS;
    }
    return DeleteSelectedFilesSuccessAction;
}());
if (false) {
    /** @type {?} */
    DeleteSelectedFilesSuccessAction.prototype.type;
    /** @type {?} */
    DeleteSelectedFilesSuccessAction.prototype.payload;
}
var InverseFilesSelectionAction = /** @class */ (function () {
    function InverseFilesSelectionAction() {
        this.type = FileManagerActionTypes.INVERSE_FILE_SELECTION;
    }
    return InverseFilesSelectionAction;
}());
if (false) {
    /** @type {?} */
    InverseFilesSelectionAction.prototype.type;
}
var LoadFilesAction = /** @class */ (function () {
    function LoadFilesAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.LOAD_FILES;
    }
    return LoadFilesAction;
}());
if (false) {
    /** @type {?} */
    LoadFilesAction.prototype.type;
    /** @type {?} */
    LoadFilesAction.prototype.payload;
}
var LoadFilesSuccessAction = /** @class */ (function () {
    function LoadFilesSuccessAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.LOAD_FILES_SUCCESS;
    }
    return LoadFilesSuccessAction;
}());
if (false) {
    /** @type {?} */
    LoadFilesSuccessAction.prototype.type;
    /** @type {?} */
    LoadFilesSuccessAction.prototype.payload;
}
var MoveFilesErrorAction = /** @class */ (function () {
    function MoveFilesErrorAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.MOVE_FILES_ERROR;
    }
    return MoveFilesErrorAction;
}());
if (false) {
    /** @type {?} */
    MoveFilesErrorAction.prototype.type;
    /** @type {?} */
    MoveFilesErrorAction.prototype.payload;
}
var MoveFilesSuccessAction = /** @class */ (function () {
    function MoveFilesSuccessAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.MOVE_FILES_SUCCESS;
    }
    return MoveFilesSuccessAction;
}());
if (false) {
    /** @type {?} */
    MoveFilesSuccessAction.prototype.type;
    /** @type {?} */
    MoveFilesSuccessAction.prototype.payload;
}
var SelectAllFilesAction = /** @class */ (function () {
    function SelectAllFilesAction() {
        this.type = FileManagerActionTypes.SELECT_ALL;
    }
    return SelectAllFilesAction;
}());
if (false) {
    /** @type {?} */
    SelectAllFilesAction.prototype.type;
}
var SelectFileAction = /** @class */ (function () {
    function SelectFileAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.SELECT_FILE;
    }
    return SelectFileAction;
}());
if (false) {
    /** @type {?} */
    SelectFileAction.prototype.type;
    /** @type {?} */
    SelectFileAction.prototype.payload;
}
var UnSelectAllFilesAction = /** @class */ (function () {
    function UnSelectAllFilesAction() {
        this.type = FileManagerActionTypes.UNSELECT_ALL;
    }
    return UnSelectAllFilesAction;
}());
if (false) {
    /** @type {?} */
    UnSelectAllFilesAction.prototype.type;
}
var UnSelectFileAction = /** @class */ (function () {
    function UnSelectFileAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.UNSELECT_FILE;
    }
    return UnSelectFileAction;
}());
if (false) {
    /** @type {?} */
    UnSelectFileAction.prototype.type;
    /** @type {?} */
    UnSelectFileAction.prototype.payload;
}
var UploadFilesAction = /** @class */ (function () {
    function UploadFilesAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.UPLOAD_FILE;
    }
    return UploadFilesAction;
}());
if (false) {
    /** @type {?} */
    UploadFilesAction.prototype.type;
    /** @type {?} */
    UploadFilesAction.prototype.payload;
}
var UploadFilesErrorAction = /** @class */ (function () {
    function UploadFilesErrorAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.UPLOAD_FILE_ERROR;
    }
    return UploadFilesErrorAction;
}());
if (false) {
    /** @type {?} */
    UploadFilesErrorAction.prototype.type;
    /** @type {?} */
    UploadFilesErrorAction.prototype.payload;
}
var UploadFilesSuccessAction = /** @class */ (function () {
    function UploadFilesSuccessAction(payload) {
        this.payload = payload;
        this.type = FileManagerActionTypes.UPLOAD_FILE_SUCCESS;
    }
    return UploadFilesSuccessAction;
}());
if (false) {
    /** @type {?} */
    UploadFilesSuccessAction.prototype.type;
    /** @type {?} */
    UploadFilesSuccessAction.prototype.payload;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CropComponent = /** @class */ (function () {
    function CropComponent(resolver, configuration, store, filemanagerTranslations) {
        this.resolver = resolver;
        this.configuration = configuration;
        this.store = store;
        this.filemanagerTranslations = filemanagerTranslations;
        this.onCrop = new EventEmitter();
        this.cropSizeList = configuration.allowedCropSize;
    }
    /**
     * @param {?} cropSize
     * @return {?}
     */
    CropComponent.prototype.updateCropSize = /**
     * @param {?} cropSize
     * @return {?}
     */
    function (cropSize) {
        var _this = this;
        /** @type {?} */
        var image = new Image();
        /** @type {?} */
        var cropperComponent = this.resolver.resolveComponentFactory(ImageCropperComponent);
        /** @type {?} */
        var cropperComponentRef = this.container.createComponent(cropperComponent);
        if (this.container.length > 1) {
            this.container.detach(0);
        }
        this.currentCropSize = cropSize;
        cropperComponentRef.instance.settings = this.getCropperSettings();
        cropperComponentRef.instance.image = {};
        cropperComponentRef.instance.onCrop
            .subscribe((/**
         * @param {?} bounds
         * @return {?}
         */
        function (bounds) { return _this.bounds = bounds; }));
        setTimeout((/**
         * @return {?}
         */
        function () {
            image.src = _this.file.url;
            cropperComponentRef.instance.setImage(image);
        }));
    };
    /**
     * @return {?}
     */
    CropComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        this.updateCropSize(this.cropSizeList[0]);
    };
    /**
     * @return {?}
     */
    CropComponent.prototype.cropImage = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var bounds = {
            x: this.bounds.left,
            y: this.bounds.top,
            width: this.bounds.width,
            height: this.bounds.height
        };
        this.store.dispatch(new CropFileAction({ file: this.file, bounds: bounds }));
    };
    /**
     * @private
     * @return {?}
     */
    CropComponent.prototype.getCropperSettings = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var cropperSettings = new CropperSettings();
        /** @type {?} */
        var scale = this.calculateScale();
        /** @type {?} */
        var width = scale * this.file.getWidth();
        /** @type {?} */
        var height = scale * this.file.getHeight();
        cropperSettings.noFileInput = true;
        cropperSettings.width = this.currentCropSize.width;
        cropperSettings.height = this.currentCropSize.height;
        cropperSettings.canvasWidth = width;
        cropperSettings.canvasHeight = height;
        return cropperSettings;
    };
    /**
     * Calculates scale between current file dimensions and box 600x600
     */
    /**
     * Calculates scale between current file dimensions and box 600x600
     * @private
     * @return {?}
     */
    CropComponent.prototype.calculateScale = /**
     * Calculates scale between current file dimensions and box 600x600
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var scale = this.file.getWidth() / this.file.getHeight();
        if (scale > 1) {
            if (this.file.getWidth() > 600) {
                return 600 / this.file.getWidth();
            }
        }
        else {
            if (this.file.getHeight() > 600) {
                return 600 / this.file.getHeight();
            }
        }
        return 1;
    };
    CropComponent.decorators = [
        { type: Component, args: [{
                    selector: 'crop-image',
                    template: "\n      <div class=\"crop-image\">\n          <div class=\"crop-workbench\">\n              <div #container></div>\n          </div>\n          <div class=\"btn-toolbar\">\n              <div class=\"btn-group\">\n                  <button class=\"btn btn-primary\" *ngFor=\"let cropSize of cropSizeList\" (click)=\"updateCropSize(cropSize)\"\n                          [ngClass]=\"{'active': cropSize == currentCropSize}\">{{cropSize.name}}\n                  </button>\n              </div>\n              <div class=\"btn-group pull-right\">\n                  <button class=\"btn btn-success btn-icon\" (click)=\"cropImage()\">\n                      <i class=\"fa fa-check\"></i>\n                      <span>{{ filemanagerTranslations.RI_FM_BTN_SAVE }}</span>\n                  </button>\n              </div>\n          </div>\n      </div>\n  ",
                    styles: [".btn-toolbar{margin:5px 0}.btn-toolbar .btn-group{margin:0}.crop-workbench{width:600px;height:400px;text-align:center}"]
                }] }
    ];
    /** @nocollapse */
    CropComponent.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: FileManagerConfiguration },
        { type: Store },
        { type: undefined, decorators: [{ type: Inject, args: [FILEMANAGER_TRANSLATION_TOKEN,] }] }
    ]; };
    CropComponent.propDecorators = {
        file: [{ type: Input }],
        onCrop: [{ type: Output }],
        container: [{ type: ViewChild, args: ['container', { read: ViewContainerRef, static: true },] }],
        cropper: [{ type: ViewChild, args: ['cropper', { static: false },] }]
    };
    return CropComponent;
}());
if (false) {
    /** @type {?} */
    CropComponent.prototype.file;
    /** @type {?} */
    CropComponent.prototype.onCrop;
    /** @type {?} */
    CropComponent.prototype.container;
    /** @type {?} */
    CropComponent.prototype.cropper;
    /**
     * @type {?}
     * @private
     */
    CropComponent.prototype.bounds;
    /** @type {?} */
    CropComponent.prototype.cropSizeList;
    /** @type {?} */
    CropComponent.prototype.currentCropSize;
    /**
     * @type {?}
     * @private
     */
    CropComponent.prototype.resolver;
    /**
     * @type {?}
     * @private
     */
    CropComponent.prototype.configuration;
    /**
     * @type {?}
     * @private
     */
    CropComponent.prototype.store;
    /** @type {?} */
    CropComponent.prototype.filemanagerTranslations;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ICropBounds() { }
if (false) {
    /** @type {?} */
    ICropBounds.prototype.x;
    /** @type {?} */
    ICropBounds.prototype.y;
    /** @type {?} */
    ICropBounds.prototype.width;
    /** @type {?} */
    ICropBounds.prototype.height;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ICropSize() { }
if (false) {
    /** @type {?} */
    ICropSize.prototype.name;
    /** @type {?} */
    ICropSize.prototype.width;
    /** @type {?} */
    ICropSize.prototype.height;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DropdownComponent = /** @class */ (function () {
    function DropdownComponent() {
        this.onClick = new EventEmitter();
        this.isOpen = false;
    }
    /**
     * @return {?}
     */
    DropdownComponent.prototype.hide = /**
     * @return {?}
     */
    function () {
        this.isOpen = false;
    };
    /**
     * @param {?} button
     * @return {?}
     */
    DropdownComponent.prototype.selectButton = /**
     * @param {?} button
     * @return {?}
     */
    function (button) {
        this.hide();
        this.onClick.emit(button);
    };
    /**
     * @return {?}
     */
    DropdownComponent.prototype.toggleOpen = /**
     * @return {?}
     */
    function () {
        this.isOpen = !this.isOpen;
    };
    DropdownComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ri-dropdown',
                    template: "<div class=\"btn-group dropdown\" [ngClass]=\"{'show': isOpen}\">\n  <button class=\"btn btn-secondary\" [ngClass]=\"{disabled: mainButton.disabled}\" (click)=\"selectButton(mainButton)\">\n    <span *ngIf=\"displayMainButtonLabel\">{{mainButton.name}}</span>\n    <i *ngIf=\"mainButton.icon\" class=\"{{mainButton.iconCssClass}}\"></i>\n  </button><!--\n  -->\n  <button class=\"btn btn-secondary dropdown-toggle dropdown-toggle-split\" id=\"dropdownMenuButton\"\n          [ngClass]=\"{disabled: mainButton.disabled}\"\n          (click)=\"toggleOpen()\">\n    <span class=\"caret\"></span>\n  </button>\n  <ul class=\"dropdown-menu\" role=\"menu\" aria-labelledby=\"single-button\" (mouseleave)=\"hide()\"\n      [ngClass]=\"{'show': isOpen}\">\n    <li class=\"\"\n        [ngClass]=\"{'dropdown-divider': button.isDivider(), 'dropdown-item': !button.isDivider(), disabled: button.disabled}\"\n        *ngFor=\"let button of buttons \" (click)=\"selectButton(button)\">\n      <span *ngIf=\"button.icon\" class=\"{{button.iconCssClass}}\"></span>\n      <span *ngIf=\"button.label\">{{button.name}}</span>\n    </li>\n  </ul>\n</div>\n",
                    styles: [".dropdown{display:inline-block;height:34px}.dropdown .btn{height:34px}.dropdown li{cursor:pointer}.dropdown li:hover:not(.disabled){background:rgba(0,123,255,.45)}"]
                }] }
    ];
    DropdownComponent.propDecorators = {
        mainButton: [{ type: Input }],
        buttons: [{ type: Input }],
        displayMainButtonLabel: [{ type: Input }],
        onClick: [{ type: Output }]
    };
    return DropdownComponent;
}());
if (false) {
    /** @type {?} */
    DropdownComponent.prototype.mainButton;
    /** @type {?} */
    DropdownComponent.prototype.buttons;
    /** @type {?} */
    DropdownComponent.prototype.displayMainButtonLabel;
    /** @type {?} */
    DropdownComponent.prototype.onClick;
    /** @type {?} */
    DropdownComponent.prototype.isOpen;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IFileDataProperties() { }
if (false) {
    /** @type {?} */
    IFileDataProperties.prototype.id;
    /** @type {?} */
    IFileDataProperties.prototype.folderId;
    /** @type {?} */
    IFileDataProperties.prototype.name;
    /** @type {?} */
    IFileDataProperties.prototype.size;
    /** @type {?} */
    IFileDataProperties.prototype.data;
    /** @type {?} */
    IFileDataProperties.prototype.type;
    /** @type {?|undefined} */
    IFileDataProperties.prototype.width;
    /** @type {?|undefined} */
    IFileDataProperties.prototype.height;
    /** @type {?|undefined} */
    IFileDataProperties.prototype.selected;
}
/**
 * @record
 */
function IImageDimensions() { }
if (false) {
    /** @type {?} */
    IImageDimensions.prototype.width;
    /** @type {?} */
    IImageDimensions.prototype.height;
}
var ImageDataConverter = /** @class */ (function () {
    function ImageDataConverter() {
    }
    /**
     * @param {?} file
     * @param {?} folderId
     * @return {?}
     */
    ImageDataConverter.prototype.getProperties = /**
     * @param {?} file
     * @param {?} folderId
     * @return {?}
     */
    function (file, folderId) {
        var _this = this;
        /** @type {?} */
        var properties = {
            id: UUID.UUID(),
            folderId: folderId,
            name: file.name,
            size: file.size,
            type: file.type,
            data: ''
        };
        /** @type {?} */
        var reader = this.getBase64FromFile(file);
        return reader
            .pipe(concatMap((/**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            properties.data = data;
            if (properties.type.indexOf('image') === 0) {
                return _this.getImageDimensions(data);
            }
            else {
                return of({ width: 0, height: 0 });
            }
        })), map((/**
         * @param {?} dimensions
         * @return {?}
         */
        function (dimensions) {
            properties.width = dimensions.width;
            properties.height = dimensions.height;
            return properties;
        })));
    };
    /**
     * Create observable which return image as base64 data
     */
    /**
     * Create observable which return image as base64 data
     * @private
     * @param {?} file
     * @return {?}
     */
    ImageDataConverter.prototype.getBase64FromFile = /**
     * Create observable which return image as base64 data
     * @private
     * @param {?} file
     * @return {?}
     */
    function (file) {
        /** @type {?} */
        var reader = new FileReader();
        reader.readAsDataURL(file);
        return fromEvent(reader, 'load')
            .pipe(map((/**
         * @return {?}
         */
        function () {
            return reader.result.toString();
        })));
    };
    /**
     * Create observable which return dimensions of the image
     */
    /**
     * Create observable which return dimensions of the image
     * @private
     * @param {?} data
     * @return {?}
     */
    ImageDataConverter.prototype.getImageDimensions = /**
     * Create observable which return dimensions of the image
     * @private
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var image = new Image();
        image.src = data;
        image.style.display = 'none';
        /** @type {?} */
        var loadImage = fromEvent(image, 'load')
            .pipe(map((/**
         * @return {?}
         */
        function () {
            return {
                width: image.naturalWidth,
                height: image.naturalHeight
            };
        })));
        document.body.appendChild(image);
        return loadImage;
    };
    ImageDataConverter.decorators = [
        { type: Injectable }
    ];
    return ImageDataConverter;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ExtendedFileUploader = /** @class */ (function (_super) {
    __extends(ExtendedFileUploader, _super);
    function ExtendedFileUploader(options, filemanagerNotification) {
        var _this = _super.call(this, options) || this;
        _this.filemanagerNotification = filemanagerNotification;
        return _this;
    }
    /**
     * @param {?} item
     * @param {?} filter
     * @param {?} options
     * @return {?}
     */
    ExtendedFileUploader.prototype.onWhenAddingFileFailed = /**
     * @param {?} item
     * @param {?} filter
     * @param {?} options
     * @return {?}
     */
    function (item, filter, options) {
        /** @type {?} */
        var notification = {
            type: 'alert',
            title: 'Add file to queue',
            message: "File not add to queue"
        };
        if (filter.name === 'fileSize') {
            notification.message = "File size is too large - max size  is " + options.maxFileSize / 1024 + " KB";
        }
        else {
            notification.message = "File mime type \"" + item.type + "\" is not allowed";
        }
        this.filemanagerNotification.send(notification);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    ExtendedFileUploader.prototype.uploadItem = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        if (this.options.url) {
            _super.prototype.uploadItem.call(this, value);
        }
        else {
            /** @type {?} */
            var imageDataConverter = new ImageDataConverter();
            this._onProgressItem(value, 0);
            if (this.isUploading) {
                return;
            }
            this.isUploading = true;
            /** @type {?} */
            var header = this.options.headers.find((/**
             * @param {?} object
             * @return {?}
             */
            function (object) { return object.name === 'folderId'; }));
            this._onProgressItem(value, 50);
            imageDataConverter.getProperties(value._file, header.value)
                .subscribe((/**
             * @param {?} file
             * @return {?}
             */
            function (file) {
                _this.isUploading = false;
                _this._onProgressItem(value, 100);
                _this._onCompleteItem(value, JSON.stringify(file), 200, {});
            }));
        }
    };
    return ExtendedFileUploader;
}(FileUploader));
if (false) {
    /**
     * @type {?}
     * @private
     */
    ExtendedFileUploader.prototype.filemanagerNotification;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FilemanagerNotifications = /** @class */ (function () {
    function FilemanagerNotifications() {
        this._notification$ = new Subject();
        this.notification$ = this._notification$.asObservable();
    }
    /**
     * @param {?} notification
     * @return {?}
     */
    FilemanagerNotifications.prototype.send = /**
     * @param {?} notification
     * @return {?}
     */
    function (notification) {
        this._notification$.next(notification);
    };
    return FilemanagerNotifications;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    FilemanagerNotifications.prototype._notification$;
    /** @type {?} */
    FilemanagerNotifications.prototype.notification$;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileManagerUploader = /** @class */ (function () {
    function FileManagerUploader(configuration, filemanagerNotification) {
        /** @type {?} */
        var options = {
            allowedMimeType: configuration.mimeTypes,
            url: configuration.urls.filesUrl,
            maxFileSize: configuration.maxFileSize
        };
        this.uploader = new ExtendedFileUploader(options, filemanagerNotification);
    }
    /**
     * @return {?}
     */
    FileManagerUploader.prototype.clear = /**
     * @return {?}
     */
    function () {
        this.uploader.authToken = null;
        this.uploader.setOptions(this.getDefaultOptions());
    };
    /**
     * @return {?}
     */
    FileManagerUploader.prototype.getDefaultOptions = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var options = {};
        options['removeAfterUpload'] = true;
        options['autoUpload'] = true;
        options['method'] = 'POST';
        return options;
    };
    /**
     * @param {?} token
     * @return {?}
     */
    FileManagerUploader.prototype.setAuthorizationToken = /**
     * @param {?} token
     * @return {?}
     */
    function (token) {
        this.uploader.authToken = token;
    };
    /**
     * @param {?} directoryId
     * @return {?}
     */
    FileManagerUploader.prototype.setDirectoryId = /**
     * @param {?} directoryId
     * @return {?}
     */
    function (directoryId) {
        /** @type {?} */
        var options = this.getDefaultOptions();
        options['headers'] = [{ name: 'folderId', value: directoryId.toString() }];
        this.uploader.setOptions(options);
        return this;
    };
    FileManagerUploader.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    FileManagerUploader.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: ['fileManagerConfiguration',] }] },
        { type: FilemanagerNotifications }
    ]; };
    return FileManagerUploader;
}());
if (false) {
    /** @type {?} */
    FileManagerUploader.prototype.uploader;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileComponent = /** @class */ (function () {
    function FileComponent(configuration, store, filemanagerTranslations) {
        this.configuration = configuration;
        this.store = store;
        this.filemanagerTranslations = filemanagerTranslations;
        this.onPreviewFile = new EventEmitter();
        this.onCropFile = new EventEmitter();
        this.onSelectFile = new EventEmitter();
    }
    /**
     * Fired when clicked on button "delete file"
     */
    /**
     * Fired when clicked on button "delete file"
     * @param {?} $event
     * @param {?} file
     * @return {?}
     */
    FileComponent.prototype.deleteFile = /**
     * Fired when clicked on button "delete file"
     * @param {?} $event
     * @param {?} file
     * @return {?}
     */
    function ($event, file) {
        this.store.dispatch(new DeleteFileAction({ file: file }));
        $event.preventDefault();
        $event.stopPropagation();
    };
    /**
     * @param {?} file
     * @return {?}
     */
    FileComponent.prototype.getRemoveMessage = /**
     * @param {?} file
     * @return {?}
     */
    function (file) {
        return this.filemanagerTranslations.RI_FM_MSG_REMOVE_QUESTION.replace('${FILENAME}', file.name);
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    FileComponent.prototype.openPreview = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        /** @type {?} */
        var fileEvent = {
            eventName: 'onPreviewFile',
            file: this.file
        };
        this.onPreviewFile.emit(fileEvent);
        $event.preventDefault();
        $event.stopPropagation();
    };
    /**
     * @param {?} $event
     * @return {?}
     */
    FileComponent.prototype.openCrop = /**
     * @param {?} $event
     * @return {?}
     */
    function ($event) {
        /** @type {?} */
        var fileEvent = {
            eventName: 'onCropFile',
            file: this.file
        };
        this.onCropFile.emit(fileEvent);
        $event.preventDefault();
        $event.stopPropagation();
    };
    /**
     * @return {?}
     */
    FileComponent.prototype.selectFile = /**
     * @return {?}
     */
    function () {
        this.store.dispatch(new SelectFileAction({ file: this.file }));
    };
    /**
     * @return {?}
     */
    FileComponent.prototype.unSelectFile = /**
     * @return {?}
     */
    function () {
        this.store.dispatch(new UnSelectFileAction({ file: this.file }));
    };
    /**
     * @param {?} $event
     * @param {?} file
     * @return {?}
     */
    FileComponent.prototype.chooseFile = /**
     * @param {?} $event
     * @param {?} file
     * @return {?}
     */
    function ($event, file) {
        this.store.dispatch(new ChooseFilesAction({ files: [file.toJSON()] }));
        $event.preventDefault();
        $event.stopPropagation();
    };
    FileComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ri-file-component',
                    template: "<div *ngIf=\"configuration.isMultiSelection\" class=\"file-selection-input\">\n  <i class=\"fa fa-2x checked fa-check-square-o\" (click)=\"unSelectFile()\"></i>\n  <i class=\"fa fa-2x unchecked fa-square-o\" (click)=\"selectFile()\"></i>\n</div>\n<div class=\"rounded file-img\" [ngClass]=\"{'file-img-symbol': !file.isImage()}\"\n     [style.background-image]=\"'url(' + file.thumbnailUrl + ')'\"></div>\n<span class=\"file-name\">{{file.name}}</span>\n<div class=\"file-menu\">\n  <div class=\"btn-group btn-group-sm\">\n    <button mwlConfirmationPopover\n            [popoverTitle]=\"filemanagerTranslations.RI_FM_LBL_REMOVE_TITLE\"\n            [popoverMessage]=\"getRemoveMessage(file)\"\n            [appendToBody]=\"true\"\n            [confirmText]=\"filemanagerTranslations.RI_FM_BTN_DELETE_YES\"\n            [cancelText]=\"filemanagerTranslations.RI_FM_BTN_DELETE_NO\"\n            placement=\"bottom\"\n            (confirm)=\"deleteFile($event.clickEvent, file)\"\n            class=\"btn btn-sm btn-danger btn-icon\">\n      <i class=\"fa fa-trash\"></i>\n    </button>\n    <button (click)=\"openPreview($event)\" class=\"btn btn-sm btn-secondary btn-icon\">\n      <i class=\"fa fa-search\"></i>\n    </button>\n    <button *ngIf=\"file.isImage()\" (click)=\"openCrop($event)\" class=\"btn btn-sm btn-secondary btn-icon\">\n      <i class=\"fa fa-crop\"></i>\n    </button>\n    <button *ngIf=\"file.isImage()\" (click)=\"chooseFile($event, file)\" class=\"btn btn-sm btn-primary btn-icon\">\n      <i class=\"fa fa-image\"></i>\n    </button>\n  </div>\n</div>\n",
                    encapsulation: ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    FileComponent.ctorParameters = function () { return [
        { type: FileManagerConfiguration },
        { type: Store },
        { type: undefined, decorators: [{ type: Inject, args: [FILEMANAGER_TRANSLATION_TOKEN,] }] }
    ]; };
    FileComponent.propDecorators = {
        file: [{ type: Input }],
        onPreviewFile: [{ type: Output }],
        onCropFile: [{ type: Output }],
        onSelectFile: [{ type: Output }]
    };
    return FileComponent;
}());
if (false) {
    /** @type {?} */
    FileComponent.prototype.file;
    /** @type {?} */
    FileComponent.prototype.onPreviewFile;
    /** @type {?} */
    FileComponent.prototype.onCropFile;
    /** @type {?} */
    FileComponent.prototype.onSelectFile;
    /** @type {?} */
    FileComponent.prototype.configuration;
    /**
     * @type {?}
     * @private
     */
    FileComponent.prototype.store;
    /** @type {?} */
    FileComponent.prototype.filemanagerTranslations;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ISelectFile() { }
if (false) {
    /** @type {?} */
    ISelectFile.prototype.id;
    /** @type {?} */
    ISelectFile.prototype.name;
    /** @type {?} */
    ISelectFile.prototype.url;
    /** @type {?} */
    ISelectFile.prototype.width;
    /** @type {?} */
    ISelectFile.prototype.height;
    /** @type {?} */
    ISelectFile.prototype.mime;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IOuterFile() { }
if (false) {
    /** @type {?} */
    IOuterFile.prototype.id;
    /** @type {?|undefined} */
    IOuterFile.prototype.folderId;
    /** @type {?} */
    IOuterFile.prototype.name;
    /** @type {?} */
    IOuterFile.prototype.thumbnailUrl;
    /** @type {?} */
    IOuterFile.prototype.url;
    /** @type {?} */
    IOuterFile.prototype.width;
    /** @type {?} */
    IOuterFile.prototype.height;
    /** @type {?} */
    IOuterFile.prototype.type;
    /** @type {?|undefined} */
    IOuterFile.prototype.data;
    /** @type {?|undefined} */
    IOuterFile.prototype.size;
    /** @type {?|undefined} */
    IOuterFile.prototype.selected;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var FILEMANAGER_TREE_NAME = 'fileManagerTree';
/**
 * @abstract
 */
var  /**
 * @abstract
 */
AbstractFileManagerApiService = /** @class */ (function () {
    function AbstractFileManagerApiService() {
        this.treeName = FILEMANAGER_TREE_NAME;
        this.fileManagerName = 'fileManagerFiles';
        this.currentNodeId = '';
    }
    return AbstractFileManagerApiService;
}());
if (false) {
    /**
     * @type {?}
     * @protected
     */
    AbstractFileManagerApiService.prototype.treeName;
    /**
     * @type {?}
     * @protected
     */
    AbstractFileManagerApiService.prototype.fileManagerName;
    /**
     * @type {?}
     * @protected
     */
    AbstractFileManagerApiService.prototype.nodes;
    /**
     * @type {?}
     * @protected
     */
    AbstractFileManagerApiService.prototype.files;
    /**
     * @type {?}
     * @protected
     */
    AbstractFileManagerApiService.prototype.currentNodeId;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FilesListComponent = /** @class */ (function () {
    function FilesListComponent(configuration, store) {
        this.configuration = configuration;
        this.store = store;
        this.onPreviewFile = new EventEmitter();
        this.onCropFile = new EventEmitter();
        this.onSelectFile = new EventEmitter();
        this.removeTitle = 'Remove file';
        this.dragZone = FILEMANAGER_TREE_NAME;
    }
    /**
     * Fired when clicked on button "delete file"
     */
    /**
     * Fired when clicked on button "delete file"
     * @param {?} file
     * @return {?}
     */
    FilesListComponent.prototype.deleteFile = /**
     * Fired when clicked on button "delete file"
     * @param {?} file
     * @return {?}
     */
    function (file) {
        this.store.dispatch(new DeleteFileAction({ file: file }));
    };
    /**
     * @param {?} fileEvent
     * @return {?}
     */
    FilesListComponent.prototype.openPreview = /**
     * @param {?} fileEvent
     * @return {?}
     */
    function (fileEvent) {
        this.onPreviewFile.emit(fileEvent);
    };
    /**
     * @param {?} fileEvent
     * @return {?}
     */
    FilesListComponent.prototype.openCrop = /**
     * @param {?} fileEvent
     * @return {?}
     */
    function (fileEvent) {
        this.onCropFile.emit(fileEvent);
    };
    /**
     * @param {?} file
     * @return {?}
     */
    FilesListComponent.prototype.toggleSelection = /**
     * @param {?} file
     * @return {?}
     */
    function (file) {
        if (file.selected) {
            this.store.dispatch(new UnSelectFileAction({ file: file }));
        }
        else {
            this.store.dispatch(new SelectFileAction({ file: file }));
        }
    };
    /**
     * @param {?} file
     * @return {?}
     */
    FilesListComponent.prototype.isSelected = /**
     * @param {?} file
     * @return {?}
     */
    function (file) {
        return this.selectedFiles.indexOf(file.getId().toString()) > -1;
    };
    FilesListComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ri-files-list',
                    template: "<div class=\"files-list\">\n  <div class=\"file\" *ngFor=\"let file of files\" [ngClass]=\"{'selected': isSelected(file)}\"  riDraggable [data]=\"file.toJSON()\" [sourceType]=\"'FILE'\" [dragZone]=\"dragZone\">\n    <ri-file-component [file]=\"file\" (onPreviewFile)=\"openPreview($event)\" (onCropFile)=\"openCrop($event)\"></ri-file-component>\n  </div>\n</div>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    styles: [".files-list .file{display:inline-block;position:relative;cursor:pointer;text-align:center;width:140px;height:110px;padding:5px;border:1px solid #ccc;background-color:#eee;border-radius:10px;margin:0 0 20px 20px}.files-list .file .file-img{width:128px;height:98px;background-size:cover;background-repeat:no-repeat}.files-list .file .file-img.file-img-symbol{background-size:contain;background-position-x:50%}.files-list .file .file-name{display:none;position:absolute;bottom:0;left:0;right:0;text-align:center;background-color:rgba(238,238,238,.5)}.files-list .file .file-menu{display:none;position:absolute;top:30%;left:0;right:0;text-align:center}.files-list .file .file-selection-input{display:none;position:absolute;top:3px;left:3px;cursor:pointer;z-index:10}.files-list .file .file-selection-input .checked{display:none}.files-list .file .file-selection-input .unchecked{display:block}.files-list .file:hover .file-img{opacity:.3}.files-list .file:hover .file-menu,.files-list .file:hover .file-name,.files-list .file:hover .file-selection-input{display:block}.files-list .file.selected{border-color:#fff33a;background-color:rgba(255,243,58,.5)}.files-list .file.selected .file-name{background-color:rgba(255,243,58,.5)}.files-list .file.selected .file-menu,.files-list .file.selected .file-selection-input{display:none}.files-list .file.selected .file-selection-input .checked{display:block}.files-list .file.selected .file-selection-input .unchecked{display:none}.files-list .file.selected:hover .file-selection-input{display:block}"]
                }] }
    ];
    /** @nocollapse */
    FilesListComponent.ctorParameters = function () { return [
        { type: FileManagerConfiguration },
        { type: Store }
    ]; };
    FilesListComponent.propDecorators = {
        files: [{ type: Input }],
        selectedFiles: [{ type: Input }],
        onPreviewFile: [{ type: Output }],
        onCropFile: [{ type: Output }],
        onSelectFile: [{ type: Output }]
    };
    return FilesListComponent;
}());
if (false) {
    /** @type {?} */
    FilesListComponent.prototype.files;
    /** @type {?} */
    FilesListComponent.prototype.selectedFiles;
    /** @type {?} */
    FilesListComponent.prototype.onPreviewFile;
    /** @type {?} */
    FilesListComponent.prototype.onCropFile;
    /** @type {?} */
    FilesListComponent.prototype.onSelectFile;
    /** @type {?} */
    FilesListComponent.prototype.removeTitle;
    /** @type {?} */
    FilesListComponent.prototype.dragZone;
    /** @type {?} */
    FilesListComponent.prototype.configuration;
    /**
     * @type {?}
     * @private
     */
    FilesListComponent.prototype.store;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function INotification() { }
if (false) {
    /** @type {?} */
    INotification.prototype.type;
    /** @type {?} */
    INotification.prototype.title;
    /** @type {?|undefined} */
    INotification.prototype.message;
}
/**
 * @record
 */
function INotificationService() { }
if (false) {
    /** @type {?} */
    INotificationService.prototype.notification$;
    /**
     * @param {?} notification
     * @return {?}
     */
    INotificationService.prototype.send = function (notification) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IFilemanagerTranslation() { }
if (false) {
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_BTN_LANDSCAPE;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_BTN_PORTRAIT;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_BTN_SAVE;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_BTN_DELETE_YES;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_BTN_DELETE_NO;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_LBL_CHOOSE_SELECTION;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_LBL_DELETE_SELECTION;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_LBL_INVERSE_SELECTION;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_LBL_REMOVE_TITLE;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_LBL_SEARCH_FOR;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_LBL_SELECT_ALL;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_LBL_UNSELECT_ALL;
    /** @type {?} */
    IFilemanagerTranslation.prototype.RI_FM_MSG_REMOVE_QUESTION;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PreviewComponent = /** @class */ (function () {
    function PreviewComponent() {
        /**
         * Current index
         */
        this.currentIndex = 0;
        this.length = 0;
    }
    /**
     * @return {?}
     */
    PreviewComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.length = this.files.length;
        /** @type {?} */
        var selectedFiles = this.files
            .filter((/**
         * @param {?} file
         * @return {?}
         */
        function (file) { return file.getId() === _this.file.getId(); }));
        this.currentIndex = selectedFiles.length === 1 ? this.files.indexOf(selectedFiles[0]) : -1;
    };
    /**
     * @return {?}
     */
    PreviewComponent.prototype.next = /**
     * @return {?}
     */
    function () {
        if (this.currentIndex < this.length - 1) {
            this.currentIndex++;
        }
    };
    /**
     * @return {?}
     */
    PreviewComponent.prototype.prev = /**
     * @return {?}
     */
    function () {
        if (this.currentIndex > 0) {
            this.currentIndex--;
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    PreviewComponent.prototype.keyEvent = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (event.keyCode === 37 || event.keyCode === 74) {
            this.prev();
        }
        if (event.keyCode === 39 || event.keyCode === 75) {
            this.next();
        }
    };
    PreviewComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ri-file-preview',
                    template: "<div class=\"filemanager-preview\">\n  <div class=\"carousel slide\">\n    <div class=\"carousel-inner\" role=\"listbox\">\n      <div class=\"carousel-item\" *ngFor=\"let file of files; let i = index;\" [ngClass]=\"{'active': i == currentIndex}\">\n        <img src=\"{{file.url}}\" alt=\"{{file.name}}\" style=\"margin: 0 auto; display: block;\">\n        <div class=\"carousel-caption\">{{file.name}}</div>\n      </div>\n    </div>\n    <a class=\"left carousel-control-prev\" role=\"button\" (click)=\"prev()\" *ngIf=\"currentIndex != 0\">\n      <span class=\"fa fa-3x fa-chevron-left\" aria-hidden=\"true\"></span>\n    </a>\n    <a class=\"right carousel-control-next\" role=\"button\" (click)=\"next()\" *ngIf=\"currentIndex + 1 < length\">\n      <span class=\"fa fa-3x fa-chevron-right\" aria-hidden=\"true\"></span>\n    </a>\n  </div>\n</div>\n"
                }] }
    ];
    PreviewComponent.propDecorators = {
        files: [{ type: Input }],
        file: [{ type: Input }],
        keyEvent: [{ type: HostListener, args: ['window:keydown', ['$event'],] }]
    };
    return PreviewComponent;
}());
if (false) {
    /**
     * Collection of files
     * @type {?}
     */
    PreviewComponent.prototype.files;
    /**
     * Current viewed file
     * @type {?}
     */
    PreviewComponent.prototype.file;
    /**
     * Current index
     * @type {?}
     */
    PreviewComponent.prototype.currentIndex;
    /** @type {?} */
    PreviewComponent.prototype.length;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SearchFilterService = /** @class */ (function () {
    function SearchFilterService() {
        /**
         * File type filter
         */
        this.filter$ = new BehaviorSubject('');
    }
    /**
     * @return {?}
     */
    SearchFilterService.prototype.getValue = /**
     * @return {?}
     */
    function () {
        return this.filter$.getValue();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    SearchFilterService.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.filter$.next(value);
    };
    SearchFilterService.decorators = [
        { type: Injectable }
    ];
    return SearchFilterService;
}());
if (false) {
    /**
     * File type filter
     * @type {?}
     */
    SearchFilterService.prototype.filter$;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileTypeFilterService = /** @class */ (function () {
    function FileTypeFilterService() {
        /**
         * File type filter
         */
        this.filter$ = new BehaviorSubject(null);
    }
    /**
     * @return {?}
     */
    FileTypeFilterService.prototype.getValue = /**
     * @return {?}
     */
    function () {
        return this.filter$.getValue();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    FileTypeFilterService.prototype.setValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.filter$.next(value);
    };
    FileTypeFilterService.decorators = [
        { type: Injectable }
    ];
    return FileTypeFilterService;
}());
if (false) {
    /**
     * File type filter
     * @type {?}
     */
    FileTypeFilterService.prototype.filter$;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function StoreEntities() { }
/**
 * @record
 */
function IFileManagerState() { }
if (false) {
    /** @type {?} */
    IFileManagerState.prototype.entities;
    /** @type {?} */
    IFileManagerState.prototype.files;
    /** @type {?} */
    IFileManagerState.prototype.selectedFiles;
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function cropFile(state, action) {
    /** @type {?} */
    var file = action.payload.file;
    /** @type {?} */
    var id = file.getId().toString();
    state.entities[id] = (/** @type {?} */ (__assign({}, file.toJSON())));
    return {
        entities: state.entities,
        files: state.files,
        selectedFiles: state.selectedFiles
    };
}
/**
 * @param {?} state
 * @return {?}
 */
function inverseFilesSelection(state) {
    return {
        entities: state.entities,
        files: state.files,
        selectedFiles: state.files.filter((/**
         * @param {?} i
         * @return {?}
         */
        function (i) { return state.selectedFiles.indexOf(i) === -1; }))
    };
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function loadFiles(state, action) {
    /** @type {?} */
    var entities = {};
    /** @type {?} */
    var files = [];
    action.payload.files.map((/**
     * @param {?} file
     * @return {?}
     */
    function (file) {
        /** @type {?} */
        var id = file.id.toString();
        entities[id] = file;
        files.push(id);
    }));
    return {
        entities: entities,
        files: files,
        selectedFiles: []
    };
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function moveFiles(state, action) {
    /** @type {?} */
    var files = action.payload.files;
    /** @type {?} */
    var ids = files.map((/**
     * @param {?} file
     * @return {?}
     */
    function (file) { return file.id.toString(); }));
    /** @type {?} */
    var folderId = action.payload.folderId ? action.payload.folderId.toString() : '';
    /** @type {?} */
    var entities = __assign({}, state.entities);
    ids.forEach((/**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        /** @type {?} */
        var oldEntity = __assign({}, entities[id]);
        oldEntity.folderId = folderId;
        entities[id] = oldEntity;
    }));
    return {
        entities: entities,
        files: state.files.filter((/**
         * @param {?} i
         * @return {?}
         */
        function (i) { return ids.indexOf(i) === -1; })),
        selectedFiles: state.selectedFiles.filter((/**
         * @param {?} i
         * @return {?}
         */
        function (i) { return ids.indexOf(i) === -1; }))
    };
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function removeFile(state, action) {
    /** @type {?} */
    var id = action.payload.file.getId();
    delete state.entities[id];
    return {
        entities: state.entities,
        files: state.files.filter((/**
         * @param {?} i
         * @return {?}
         */
        function (i) { return i !== id; })),
        selectedFiles: state.selectedFiles
    };
}
/**
 * @param {?} state
 * @return {?}
 */
function removeSelectedFiles(state) {
    /** @type {?} */
    var files = state.files.filter((/**
     * @param {?} i
     * @return {?}
     */
    function (i) { return state.selectedFiles.indexOf(i) === -1; }));
    /** @type {?} */
    var entities = {};
    files.forEach((/**
     * @param {?} fileId
     * @return {?}
     */
    function (fileId) {
        entities[fileId] = state.entities[fileId];
    }));
    return {
        entities: entities,
        files: files,
        selectedFiles: []
    };
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function selectFile(state, action) {
    return {
        entities: state.entities,
        files: state.files,
        selectedFiles: __spread(state.selectedFiles, [action.payload.file.getId().toString()])
    };
}
/**
 * @param {?} state
 * @return {?}
 */
function selectAllFiles(state) {
    return {
        entities: state.entities,
        files: state.files,
        selectedFiles: __spread(state.files)
    };
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function uploadFiles(state, action) {
    /** @type {?} */
    var newState = {
        entities: __assign({}, state.entities),
        files: __spread(state.files),
        selectedFiles: []
    };
    action.payload.files.forEach((/**
     * @param {?} file
     * @return {?}
     */
    function (file) {
        /** @type {?} */
        var id = file.id.toString();
        newState.entities[id] = file;
        newState.files.push(id);
    }));
    return newState;
}
/**
 * @param {?} state
 * @return {?}
 */
function unSelectAllFiles(state) {
    return {
        entities: state.entities,
        files: state.files,
        selectedFiles: []
    };
}
/**
 * @param {?} state
 * @param {?} action
 * @return {?}
 */
function unSelectFile(state, action) {
    /** @type {?} */
    var fileId = action.payload.file.getId().toString();
    return {
        entities: state.entities,
        files: state.files,
        selectedFiles: state.selectedFiles.filter((/**
         * @param {?} id
         * @return {?}
         */
        function (id) { return id !== fileId; }))
    };
}
/**
 * @param {?=} state
 * @param {?=} action
 * @return {?}
 */
function fileManagerReducer(state, action) {
    if (state === void 0) { state = {
        entities: {},
        files: [],
        selectedFiles: []
    }; }
    switch (action.type) {
        case FileManagerActionTypes.CROP_FILE_SUCCESS:
            return cropFile(state, action);
        case FileManagerActionTypes.INVERSE_FILE_SELECTION:
            return inverseFilesSelection(state);
        case FileManagerActionTypes.DELETE_FILE_SELECTION_SUCCESS:
            return removeSelectedFiles(state);
        case FileManagerActionTypes.DELETE_FILE_SUCCESS:
            return removeFile(state, action);
        case FileManagerActionTypes.MOVE_FILES_SUCCESS:
            return moveFiles(state, action);
        case FileManagerActionTypes.LOAD_FILES_SUCCESS:
            return loadFiles(state, action);
        case FileManagerActionTypes.SELECT_ALL:
            return selectAllFiles(state);
        case FileManagerActionTypes.SELECT_FILE:
            return selectFile(state, action);
        case FileManagerActionTypes.UNSELECT_ALL:
            return unSelectAllFiles(state);
        case FileManagerActionTypes.UNSELECT_FILE:
            return unSelectFile(state, action);
        case FileManagerActionTypes.UPLOAD_FILE_SUCCESS:
            return uploadFiles(state, action);
        case FileManagerActionTypes.DELETE_FILE_SELECTION:
        case FileManagerActionTypes.CROP_FILE:
        case FileManagerActionTypes.DELETE_FILE:
        case FileManagerActionTypes.LOAD_FILES:
        case FileManagerActionTypes.MOVE_FILES_ERROR:
            return state;
        default:
            return state;
    }
}
/** @type {?} */
var filemanagerStateSelector = createFeatureSelector('files');
/** @type {?} */
var getAll = (/**
 * @param {?} state
 * @return {?}
 */
function (state) {
    return state.files.map((/**
     * @param {?} id
     * @return {?}
     */
    function (id) { return state.entities[id]; }));
});
/** @type {?} */
var isChangeStateFiles = (/**
 * @param {?} newState
 * @param {?} prevState
 * @return {?}
 */
function (newState, prevState) {
    return prevState.files.length !== newState.files.length || prevState.files.filter((/**
     * @param {?} i
     * @return {?}
     */
    function (i) { return newState.files.indexOf(i) === -1; })).length > 0;
});
/** @type {?} */
var isChangeStateSelectedFiles = (/**
 * @param {?} newState
 * @param {?} prevState
 * @return {?}
 */
function (newState, prevState) {
    return prevState.selectedFiles.length !== newState.selectedFiles.length || prevState.selectedFiles.filter((/**
     * @param {?} i
     * @return {?}
     */
    function (i) { return newState.selectedFiles.indexOf(i) === -1; })).length > 0;
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CurrentDirectoryFilesService = /** @class */ (function () {
    function CurrentDirectoryFilesService(store, fileTypeFilter, searchFilterService) {
        this.store = store;
        this.fileTypeFilter = fileTypeFilter;
        this.searchFilterService = searchFilterService;
        /** @type {?} */
        var store$ = this.store.select(filemanagerStateSelector);
        /** @type {?} */
        var observable$ = store$;
        this.entities$ = observable$
            .pipe(map((/**
         * @param {?} state
         * @return {?}
         */
        function (state) { return state.entities; })), distinctUntilChanged());
        this.currentDirectoryFileIds$ = observable$
            .pipe(map((/**
         * @param {?} state
         * @return {?}
         */
        function (state) { return state.files; })), distinctUntilChanged());
        this.selectedFiles$ = store$
            .pipe(map((/**
         * @param {?} state
         * @return {?}
         */
        function (state) { return state.selectedFiles; })));
        this.files$ = this.getFilesStream();
        this.filteredFiles$ = this.getCurrentDirectoryFilesStream();
    }
    /**
     * Return stream of files
     */
    /**
     * Return stream of files
     * @private
     * @return {?}
     */
    CurrentDirectoryFilesService.prototype.getFilesStream = /**
     * Return stream of files
     * @private
     * @return {?}
     */
    function () {
        return this.currentDirectoryFileIds$
            .pipe(withLatestFrom(this.entities$), map((/**
         * @param {?} ar
         * @return {?}
         */
        function (ar) {
            return {
                entities: ar[1],
                files: ar[0]
            };
        })), map((/**
         * @param {?} state
         * @return {?}
         */
        function (state) {
            return getAll(state)
                .map((/**
             * @param {?} file
             * @return {?}
             */
            function (file) {
                return new FileModel(file);
            }));
        })));
    };
    /**
     * Return stream of current directory filtered files
     */
    /**
     * Return stream of current directory filtered files
     * @private
     * @return {?}
     */
    CurrentDirectoryFilesService.prototype.getCurrentDirectoryFilesStream = /**
     * Return stream of current directory filtered files
     * @private
     * @return {?}
     */
    function () {
        return combineLatest(this.files$, this.fileTypeFilter.filter$, this.searchFilterService.filter$)
            .pipe(map((/**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            /** @type {?} */
            var files = data[0];
            /** @type {?} */
            var fileTypeFilter = data[1];
            /** @type {?} */
            var search = data[2].toLocaleLowerCase();
            if (search !== '') {
                files = files.filter((/**
                 * @param {?} file
                 * @return {?}
                 */
                function (file) {
                    return file.name.toLocaleLowerCase().indexOf(search) > -1;
                }));
            }
            if (fileTypeFilter && fileTypeFilter.mimes.length > 0) {
                files = files.filter((/**
                 * @param {?} file
                 * @return {?}
                 */
                function (file) {
                    return fileTypeFilter.mimes.indexOf(file.getMime()) > -1;
                }));
            }
            return files;
        })));
    };
    CurrentDirectoryFilesService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    CurrentDirectoryFilesService.ctorParameters = function () { return [
        { type: Store },
        { type: FileTypeFilterService },
        { type: SearchFilterService }
    ]; };
    return CurrentDirectoryFilesService;
}());
if (false) {
    /**
     * List of all files
     * @type {?}
     */
    CurrentDirectoryFilesService.prototype.files$;
    /**
     * List of files for current selected directory
     * @type {?}
     */
    CurrentDirectoryFilesService.prototype.filteredFiles$;
    /**
     * List of all files as JSON data
     * @type {?}
     */
    CurrentDirectoryFilesService.prototype.entities$;
    /**
     * List of selected file ids
     * @type {?}
     */
    CurrentDirectoryFilesService.prototype.selectedFiles$;
    /**
     * List of all files in current directory
     * @type {?}
     */
    CurrentDirectoryFilesService.prototype.currentDirectoryFileIds$;
    /**
     * @type {?}
     * @private
     */
    CurrentDirectoryFilesService.prototype.store;
    /**
     * @type {?}
     * @private
     */
    CurrentDirectoryFilesService.prototype.fileTypeFilter;
    /**
     * @type {?}
     * @private
     */
    CurrentDirectoryFilesService.prototype.searchFilterService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileManagerApiService = /** @class */ (function (_super) {
    __extends(FileManagerApiService, _super);
    function FileManagerApiService(filemanagerNotification) {
        var _this = _super.call(this) || this;
        _this.filemanagerNotification = filemanagerNotification;
        return _this;
    }
    Object.defineProperty(FileManagerApiService.prototype, "treeId", {
        get: /**
         * @return {?}
         */
        function () {
            return FILEMANAGER_TREE_NAME;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?=} nodeId
     * @return {?}
     */
    FileManagerApiService.prototype.load = /**
     * @param {?=} nodeId
     * @return {?}
     */
    function (nodeId) {
        if (nodeId === void 0) { nodeId = ''; }
        if (!this.nodes) {
            this.nodes = this.getAllDataFromLocalStorage();
        }
        /** @type {?} */
        var nodes = this.getChildren(nodeId);
        return of(nodes);
    };
    /**
     * @param {?} node
     * @param {?=} parentNodeId
     * @return {?}
     */
    FileManagerApiService.prototype.add = /**
     * @param {?} node
     * @param {?=} parentNodeId
     * @return {?}
     */
    function (node, parentNodeId) {
        if (parentNodeId === void 0) { parentNodeId = null; }
        node.parentId = parentNodeId;
        node.id = UUID.UUID();
        this.nodes.push(node);
        if (this.saveNodes()) {
            return of(node);
        }
        else {
            return empty();
        }
    };
    /**
     * @param {?} srcNode
     * @param {?} targetNode
     * @return {?}
     */
    FileManagerApiService.prototype.move = /**
     * @param {?} srcNode
     * @param {?} targetNode
     * @return {?}
     */
    function (srcNode, targetNode) {
        /** @type {?} */
        var srcId = srcNode.id;
        /** @type {?} */
        var targetId = targetNode ? targetNode.id : '';
        /** @type {?} */
        var index = this.findIndexByNodeId(srcId);
        this.nodes[index].parentId = targetId;
        if (this.saveNodes()) {
            return of(this.nodes[index]);
        }
        else {
            return empty();
        }
    };
    /**
     * @param {?} node
     * @return {?}
     */
    FileManagerApiService.prototype.update = /**
     * @param {?} node
     * @return {?}
     */
    function (node) {
        /** @type {?} */
        var index = this.findIndexByNodeId(node.id);
        this.nodes[index] = node;
        if (this.saveNodes()) {
            return of(node);
        }
        else {
            return empty();
        }
    };
    /**
     * @param {?} nodeId
     * @return {?}
     */
    FileManagerApiService.prototype.remove = /**
     * @param {?} nodeId
     * @return {?}
     */
    function (nodeId) {
        /** @type {?} */
        var index = this.findIndexByNodeId(nodeId);
        /** @type {?} */
        var node = this.nodes[index];
        /** @type {?} */
        var hasChildren = this.getChildren(nodeId).length > 0;
        if (!hasChildren) {
            this.nodes.splice(index, 1);
            this.saveNodes();
            return of(node);
        }
        else {
            return throwError('Node is not empty');
        }
    };
    /**
     * @param {?} nodes
     * @return {?}
     */
    FileManagerApiService.prototype.setAllNodes = /**
     * @param {?} nodes
     * @return {?}
     */
    function (nodes) {
        this.nodes = __spread(nodes);
        this.saveNodes();
    };
    /**
     * Crop file
     */
    /**
     * Crop file
     * @param {?} file
     * @param {?} bounds
     * @return {?}
     */
    FileManagerApiService.prototype.cropFile = /**
     * Crop file
     * @param {?} file
     * @param {?} bounds
     * @return {?}
     */
    function (file, bounds) {
        return throwError('This functionality is not available with LocalStorage');
    };
    /**
     * Load files from directory
     */
    /**
     * Load files from directory
     * @param {?=} nodeId
     * @return {?}
     */
    FileManagerApiService.prototype.loadFiles = /**
     * Load files from directory
     * @param {?=} nodeId
     * @return {?}
     */
    function (nodeId) {
        var _this = this;
        if (nodeId === void 0) { nodeId = ''; }
        this.currentNodeId = nodeId;
        if (!this.files) {
            this.files = this.getAllFileDataFromLocalStorage();
        }
        /** @type {?} */
        var files = this.getFilesFromFolder(nodeId);
        /** @type {?} */
        var newFiles = files.map((/**
         * @param {?} file
         * @return {?}
         */
        function (file) {
            return _this.convertLocalData2IOuterFile(file);
        }));
        return of(newFiles);
    };
    /**
     * @param {?} file
     * @return {?}
     */
    FileManagerApiService.prototype.removeFile = /**
     * @param {?} file
     * @return {?}
     */
    function (file) {
        /** @type {?} */
        var index = this.findIndexByFileId(file.id.toString());
        if (index === -1) {
            return of(false);
        }
        this.files.splice(index, 1);
        this.saveFiles();
        return of(true);
    };
    /**
     * @param {?} selectedFiles
     * @return {?}
     */
    FileManagerApiService.prototype.removeSelectedFiles = /**
     * @param {?} selectedFiles
     * @return {?}
     */
    function (selectedFiles) {
        var _this = this;
        /** @type {?} */
        var numberOfFiles = this.files.length;
        selectedFiles.forEach((/**
         * @param {?} fileId
         * @return {?}
         */
        function (fileId) {
            /** @type {?} */
            var index = _this.findIndexByFileId(fileId);
            if (index > -1) {
                _this.files.splice(index, 1);
            }
        }));
        this.saveFiles();
        return of((this.files.length + selectedFiles.length === numberOfFiles));
    };
    /**
     * @param {?} file
     * @return {?}
     */
    FileManagerApiService.prototype.uploadFile = /**
     * @param {?} file
     * @return {?}
     */
    function (file) {
        /** @type {?} */
        var fileData = this.convertIOuterFile2LocalData(file);
        this.files.push(fileData);
        if (this.saveFiles()) {
            return of(this.convertLocalData2IOuterFile(fileData));
        }
        else {
            return Observable.throw('Upload error');
        }
    };
    /**
     * @param {?} files
     * @param {?=} node
     * @return {?}
     */
    FileManagerApiService.prototype.moveFile = /**
     * @param {?} files
     * @param {?=} node
     * @return {?}
     */
    function (files, node) {
        var _this = this;
        if (node === void 0) { node = null; }
        /** @type {?} */
        var ids = files.map((/**
         * @param {?} file
         * @return {?}
         */
        function (file) { return file.id.toString(); }));
        /** @type {?} */
        var folderId = node ? node.id.toString() : '';
        /** @type {?} */
        var movedFiles = this.files.filter((/**
         * @param {?} file
         * @return {?}
         */
        function (file) { return ids.indexOf(file.id.toString()) > -1; }));
        /** @type {?} */
        var errorMsg = 'Can not move file to the same folder';
        /** @type {?} */
        var isMovedToSameFolder = false;
        movedFiles.forEach((/**
         * @param {?} file
         * @return {?}
         */
        function (file) {
            if (node) {
                if (node.id === file.folderId) {
                }
            }
            else {
                if (file.folderId === '' || file.folderId === null) {
                    return Observable.throw(errorMsg);
                }
            }
            file.folderId = folderId;
        }));
        if (isMovedToSameFolder) {
            return Observable.throw(errorMsg);
        }
        if (this.saveFiles()) {
            return of(movedFiles.map((/**
             * @param {?} file
             * @return {?}
             */
            function (file) { return _this.convertLocalData2IOuterFile(file); })));
        }
        else {
            return Observable.throw('Move files error');
        }
    };
    /**
     * @private
     * @param {?} nodeId
     * @return {?}
     */
    FileManagerApiService.prototype.findIndexByNodeId = /**
     * @private
     * @param {?} nodeId
     * @return {?}
     */
    function (nodeId) {
        return this.nodes.findIndex((/**
         * @param {?} node
         * @return {?}
         */
        function (node) {
            return node.id === nodeId;
        }));
    };
    /**
     * @private
     * @param {?} fileId
     * @return {?}
     */
    FileManagerApiService.prototype.findIndexByFileId = /**
     * @private
     * @param {?} fileId
     * @return {?}
     */
    function (fileId) {
        return this.files.findIndex((/**
         * @param {?} file
         * @return {?}
         */
        function (file) { return file.id === fileId; }));
    };
    /**
     * @private
     * @param {?} nodeId
     * @return {?}
     */
    FileManagerApiService.prototype.getChildren = /**
     * @private
     * @param {?} nodeId
     * @return {?}
     */
    function (nodeId) {
        return this.nodes.filter((/**
         * @param {?} node
         * @return {?}
         */
        function (node) { return node.parentId === nodeId; }));
    };
    /**
     * @private
     * @param {?} nodeId
     * @return {?}
     */
    FileManagerApiService.prototype.getFilesFromFolder = /**
     * @private
     * @param {?} nodeId
     * @return {?}
     */
    function (nodeId) {
        return this.files.filter((/**
         * @param {?} file
         * @return {?}
         */
        function (file) { return file.folderId === nodeId; }));
    };
    /**
     * @protected
     * @return {?}
     */
    FileManagerApiService.prototype.getAllDataFromLocalStorage = /**
     * @protected
     * @return {?}
     */
    function () {
        try {
            /** @type {?} */
            var data = localStorage.getItem(this.treeName);
            if (data) {
                return JSON.parse(data);
            }
            return [];
        }
        catch (e) {
            return [];
        }
    };
    /**
     * @protected
     * @return {?}
     */
    FileManagerApiService.prototype.getAllFileDataFromLocalStorage = /**
     * @protected
     * @return {?}
     */
    function () {
        try {
            /** @type {?} */
            var data = localStorage.getItem(this.fileManagerName);
            if (data) {
                return JSON.parse(data);
            }
            return [];
        }
        catch (e) {
            return [];
        }
    };
    /**
     * @private
     * @return {?}
     */
    FileManagerApiService.prototype.saveNodes = /**
     * @private
     * @return {?}
     */
    function () {
        try {
            localStorage.setItem(this.treeName, JSON.stringify(this.nodes));
            return true;
        }
        catch (e) {
            this.filemanagerNotification.send({
                type: 'error',
                title: 'State is not saved.',
                message: 'Reload previous state.'
            });
            this.files = null;
            this.nodes = null;
            this.load();
            return false;
        }
    };
    /**
     * @private
     * @return {?}
     */
    FileManagerApiService.prototype.saveFiles = /**
     * @private
     * @return {?}
     */
    function () {
        try {
            localStorage.setItem(this.fileManagerName, JSON.stringify(this.files));
            return true;
        }
        catch (e) {
            this.filemanagerNotification.send({
                type: 'error',
                title: 'State is not saved.',
                message: 'Reload previous state.'
            });
            /** @type {?} */
            var nodeId = this.files[(this.files.length - 1)].folderId || null;
            this.files = null;
            this.load(nodeId);
            return false;
        }
    };
    /**
     * @private
     * @param {?} file
     * @return {?}
     */
    FileManagerApiService.prototype.convertLocalData2IOuterFile = /**
     * @private
     * @param {?} file
     * @return {?}
     */
    function (file) {
        return {
            id: file.id,
            folderId: file.folderId,
            name: file.name,
            thumbnailUrl: file.data,
            url: file.data,
            width: file.width,
            height: file.height,
            type: file.type,
            size: file.size
        };
    };
    /**
     * @private
     * @param {?} file
     * @return {?}
     */
    FileManagerApiService.prototype.convertIOuterFile2LocalData = /**
     * @private
     * @param {?} file
     * @return {?}
     */
    function (file) {
        return {
            id: file.id.toString(),
            folderId: file.folderId,
            name: file.name,
            type: file.type,
            data: file.data,
            size: file.size,
            width: file.width,
            height: file.height
        };
    };
    FileManagerApiService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    FileManagerApiService.ctorParameters = function () { return [
        { type: FilemanagerNotifications }
    ]; };
    return FileManagerApiService;
}(AbstractFileManagerApiService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    FileManagerApiService.prototype.filemanagerNotification;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileManagerBackendApiService = /** @class */ (function (_super) {
    __extends(FileManagerBackendApiService, _super);
    function FileManagerBackendApiService($http, configuration) {
        var _this = _super.call(this) || this;
        _this.$http = $http;
        _this.configuration = configuration;
        _this.nodes = [];
        _this.files = [];
        return _this;
    }
    Object.defineProperty(FileManagerBackendApiService.prototype, "treeId", {
        get: /**
         * @return {?}
         */
        function () {
            return FILEMANAGER_TREE_NAME;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Load folder chidls for given folder id
     */
    /**
     * Load folder chidls for given folder id
     * @param {?=} nodeId
     * @return {?}
     */
    FileManagerBackendApiService.prototype.load = /**
     * Load folder chidls for given folder id
     * @param {?=} nodeId
     * @return {?}
     */
    function (nodeId) {
        var _this = this;
        if (nodeId === void 0) { nodeId = ''; }
        /** @type {?} */
        var nodeIds = this.nodes.map((/**
         * @param {?} node
         * @return {?}
         */
        function (node) { return node.id; }));
        /** @type {?} */
        var params = new HttpParams().set('nodeId', nodeId || '');
        return this.$http.get(this.configuration.folderUrls.foldersUrl, { params: params })
            .pipe(map((/**
         * @param {?} nodes
         * @return {?}
         */
        function (nodes) {
            nodes.forEach((/**
             * @param {?} node
             * @return {?}
             */
            function (node) {
                if (nodeIds.indexOf(node.id) === -1) {
                    _this.nodes.push(node);
                }
                else {
                    /** @type {?} */
                    var index = _this.nodes.findIndex((/**
                     * @param {?} item
                     * @return {?}
                     */
                    function (item) { return node.id === item.id; }));
                    _this.nodes[index] = node;
                }
            }));
            return nodes;
        })));
    };
    /**
     * Create new folder
     */
    /**
     * Create new folder
     * @param {?} node
     * @param {?=} parentNodeId
     * @return {?}
     */
    FileManagerBackendApiService.prototype.add = /**
     * Create new folder
     * @param {?} node
     * @param {?=} parentNodeId
     * @return {?}
     */
    function (node, parentNodeId) {
        var _this = this;
        if (parentNodeId === void 0) { parentNodeId = null; }
        /** @type {?} */
        var data = {
            node: node,
            parentNodeId: parentNodeId
        };
        return this.$http.post(this.configuration.folderUrls.foldersUrl, data)
            .pipe(map((/**
         * @param {?} newNode
         * @return {?}
         */
        function (newNode) {
            _this.nodes.push(newNode);
            return newNode;
        })));
    };
    /**
     * Move folder from source parent to target parent
     */
    /**
     * Move folder from source parent to target parent
     * @param {?} srcNode
     * @param {?} targetNode
     * @return {?}
     */
    FileManagerBackendApiService.prototype.move = /**
     * Move folder from source parent to target parent
     * @param {?} srcNode
     * @param {?} targetNode
     * @return {?}
     */
    function (srcNode, targetNode) {
        var _this = this;
        /** @type {?} */
        var srcId = srcNode.id;
        /** @type {?} */
        var targetId = targetNode ? targetNode.id : null;
        return this.$http.put(this.configuration.folderUrls.folderMoveUrl, { source: srcId, target: targetId })
            .pipe(map((/**
         * @param {?} movedNode
         * @return {?}
         */
        function (movedNode) {
            /** @type {?} */
            var index = _this.findIndexByNodeId(srcId);
            _this.nodes[index].parentId = targetId;
            return movedNode;
        })));
    };
    /**
     * Update folder name
     */
    /**
     * Update folder name
     * @param {?} node
     * @return {?}
     */
    FileManagerBackendApiService.prototype.update = /**
     * Update folder name
     * @param {?} node
     * @return {?}
     */
    function (node) {
        var _this = this;
        return this.$http.put(this.configuration.folderUrls.foldersUrl, node)
            .pipe(map((/**
         * @param {?} newNode
         * @return {?}
         */
        function (newNode) {
            /** @type {?} */
            var index = _this.findIndexByNodeId(node.id);
            _this.nodes[index] = newNode;
            return newNode;
        })));
    };
    /**
     * Remove node by given id
     */
    /**
     * Remove node by given id
     * @param {?} nodeId
     * @return {?}
     */
    FileManagerBackendApiService.prototype.remove = /**
     * Remove node by given id
     * @param {?} nodeId
     * @return {?}
     */
    function (nodeId) {
        var _this = this;
        /** @type {?} */
        var index = this.findIndexByNodeId(nodeId);
        /** @type {?} */
        var hasChildren = this.getChildren(nodeId).length > 0;
        if (!hasChildren) {
            /** @type {?} */
            var params = new HttpParams().set('nodeId', nodeId);
            return this.$http.delete(this.configuration.folderUrls.foldersUrl, { params: params })
                .pipe(map((/**
             * @param {?} removedNode
             * @return {?}
             */
            function (removedNode) {
                _this.nodes.splice(index, 1);
                return removedNode;
            })));
        }
        else {
            return Observable.throw('Node is not empty');
        }
    };
    /**
     * @param {?} nodes
     * @return {?}
     */
    FileManagerBackendApiService.prototype.setAllNodes = /**
     * @param {?} nodes
     * @return {?}
     */
    function (nodes) {
        this.nodes = __spread(nodes);
    };
    /**
     * Crop file
     */
    /**
     * Crop file
     * @param {?} file
     * @param {?} bounds
     * @return {?}
     */
    FileManagerBackendApiService.prototype.cropFile = /**
     * Crop file
     * @param {?} file
     * @param {?} bounds
     * @return {?}
     */
    function (file, bounds) {
        return this.$http.put(this.configuration.fileUrl, { id: file.id, bounds: bounds });
    };
    /**
     * Load files from directory
     */
    /**
     * Load files from directory
     * @param {?=} nodeId
     * @return {?}
     */
    FileManagerBackendApiService.prototype.loadFiles = /**
     * Load files from directory
     * @param {?=} nodeId
     * @return {?}
     */
    function (nodeId) {
        var _this = this;
        if (nodeId === void 0) { nodeId = ''; }
        this.currentNodeId = nodeId;
        /** @type {?} */
        var params = new HttpParams().set('dirId', nodeId);
        return this.$http.get(this.configuration.fileUrl, { params: params })
            .pipe(map((/**
         * @param {?} files
         * @return {?}
         */
        function (files) {
            _this.files = files.map((/**
             * @param {?} file
             * @return {?}
             */
            function (file) { return (/** @type {?} */ (file)); }));
            return files;
        })));
    };
    /**
     * Remove file from folder
     */
    /**
     * Remove file from folder
     * @param {?} file
     * @return {?}
     */
    FileManagerBackendApiService.prototype.removeFile = /**
     * Remove file from folder
     * @param {?} file
     * @return {?}
     */
    function (file) {
        var _this = this;
        /** @type {?} */
        var index = this.findIndexByFileId(file.id.toString());
        if (index === -1) {
            return of(false);
        }
        /** @type {?} */
        var params = new HttpParams().set('id', file.id.toString());
        return this.$http.delete(this.configuration.fileUrl, { params: params })
            .pipe(map((/**
         * @return {?}
         */
        function () {
            _this.files.splice(index, 1);
            return true;
        })));
    };
    /**
     * @param {?} selectedFiles
     * @return {?}
     */
    FileManagerBackendApiService.prototype.removeSelectedFiles = /**
     * @param {?} selectedFiles
     * @return {?}
     */
    function (selectedFiles) {
        var _this = this;
        /** @type {?} */
        var params = new HttpParams().set('id', selectedFiles.join('|'));
        return this.$http.delete(this.configuration.fileUrl, { params: params })
            .pipe(map((/**
         * @return {?}
         */
        function () {
            selectedFiles.forEach((/**
             * @param {?} fileId
             * @return {?}
             */
            function (fileId) {
                /** @type {?} */
                var index = _this.findIndexByFileId(fileId);
                if (index > -1) {
                    _this.files.splice(index, 1);
                }
            }));
            return true;
        })));
    };
    /**
     * This method is success method, real upload is done in ExtendedFileUploader
     */
    /**
     * This method is success method, real upload is done in ExtendedFileUploader
     * @param {?} file
     * @return {?}
     */
    FileManagerBackendApiService.prototype.uploadFile = /**
     * This method is success method, real upload is done in ExtendedFileUploader
     * @param {?} file
     * @return {?}
     */
    function (file) {
        /** @type {?} */
        var fileData = (/** @type {?} */ (file));
        this.files.push(fileData);
        return of(file);
    };
    /**
     * @param {?} files
     * @param {?} node
     * @return {?}
     */
    FileManagerBackendApiService.prototype.moveFile = /**
     * @param {?} files
     * @param {?} node
     * @return {?}
     */
    function (files, node) {
        /** @type {?} */
        var ids = files.map((/**
         * @param {?} file
         * @return {?}
         */
        function (file) { return file.id.toString(); }));
        return this.$http.put(this.configuration.fileUrl, { files: ids, folderId: node ? node.id : '' });
    };
    /**
     * @private
     * @param {?} nodeId
     * @return {?}
     */
    FileManagerBackendApiService.prototype.findIndexByNodeId = /**
     * @private
     * @param {?} nodeId
     * @return {?}
     */
    function (nodeId) {
        return this.nodes.findIndex((/**
         * @param {?} node
         * @return {?}
         */
        function (node) {
            return node.id === nodeId;
        }));
    };
    /**
     * @private
     * @param {?} fileId
     * @return {?}
     */
    FileManagerBackendApiService.prototype.findIndexByFileId = /**
     * @private
     * @param {?} fileId
     * @return {?}
     */
    function (fileId) {
        return this.files.findIndex((/**
         * @param {?} file
         * @return {?}
         */
        function (file) { return file.id === fileId; }));
    };
    /**
     * @private
     * @param {?} nodeId
     * @return {?}
     */
    FileManagerBackendApiService.prototype.getChildren = /**
     * @private
     * @param {?} nodeId
     * @return {?}
     */
    function (nodeId) {
        return this.nodes.filter((/**
         * @param {?} node
         * @return {?}
         */
        function (node) { return node.parentId === nodeId; }));
    };
    /**
     * @private
     * @param {?} file
     * @return {?}
     */
    FileManagerBackendApiService.prototype.convertLocalData2IOuterFile = /**
     * @private
     * @param {?} file
     * @return {?}
     */
    function (file) {
        return {
            id: file.id,
            folderId: file.folderId,
            name: file.name,
            thumbnailUrl: file.data,
            url: file.data,
            width: file.width,
            height: file.height,
            type: file.type,
            size: file.size
        };
    };
    /**
     * @private
     * @param {?} file
     * @return {?}
     */
    FileManagerBackendApiService.prototype.convertIOuterFile2LocalData = /**
     * @private
     * @param {?} file
     * @return {?}
     */
    function (file) {
        return {
            id: file.id.toString(),
            folderId: file.folderId,
            name: file.name,
            type: file.type,
            data: file.data,
            size: file.size,
            width: file.width,
            height: file.height
        };
    };
    FileManagerBackendApiService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    FileManagerBackendApiService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: FileManagerConfiguration }
    ]; };
    return FileManagerBackendApiService;
}(AbstractFileManagerApiService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    FileManagerBackendApiService.prototype.$http;
    /**
     * @type {?}
     * @private
     */
    FileManagerBackendApiService.prototype.configuration;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileManagerEffectsService = /** @class */ (function () {
    function FileManagerEffectsService(actions$, filemanagerNotification, fileManagerApiService) {
        var _this = this;
        this.actions$ = actions$;
        this.filemanagerNotification = filemanagerNotification;
        this.fileManagerApiService = fileManagerApiService;
        this.cropFileSuccess$ = this.actions$
            .pipe(ofType(FileManagerActionTypes.CROP_FILE_SUCCESS));
        this.deleteFileSuccess$ = this.actions$
            .pipe(ofType(FileManagerActionTypes.DELETE_FILE_SUCCESS));
        this.loadFiles$ = this.actions$
            .pipe(ofType(FileManagerActionTypes.LOAD_FILES), switchMap((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return _this.loadFiles(action.payload.folderId)
            .pipe(map((/**
         * @param {?} files
         * @return {?}
         */
        function (files) {
            return new LoadFilesSuccessAction({ files: files });
        })), catchError((/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            return of(_this.onLoadFilesError(action.payload.folderId));
        }))); })));
        this.cropFile$ = this.actions$
            .pipe(ofType(FileManagerActionTypes.CROP_FILE), switchMap((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return _this.cropFile(action.payload.file, action.payload.bounds)
            .pipe(map((/**
         * @param {?} result
         * @return {?}
         */
        function (result) {
            _this.filemanagerNotification.send({
                type: 'success',
                title: 'Crop Image.',
                message: 'Image has been cropped.'
            });
            return new CropFileSuccessAction({ file: action.payload.file });
        })), catchError((/**
         * @return {?}
         */
        function () { return of(new CropFileErrorAction({ file: action.payload.file })); }))); })));
        this.deleteFile$ = this.actions$
            .pipe(ofType(FileManagerActionTypes.DELETE_FILE), switchMap((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return _this.deleteFile(action.payload.file)
            .pipe(map((/**
         * @param {?} result
         * @return {?}
         */
        function (result) {
            return new DeleteFileSuccessAction({ file: action.payload.file });
        })), catchError((/**
         * @return {?}
         */
        function () { return of(_this.onDeleteFileError(action.payload.file)); }))); })));
        this.deleteFilesSelection$ = this.actions$
            .pipe(ofType(FileManagerActionTypes.DELETE_FILE_SELECTION), switchMap((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return _this.deleteFilesSelection(action.payload.files)
            .pipe(map((/**
         * @param {?} result
         * @return {?}
         */
        function (result) {
            return new DeleteSelectedFilesSuccessAction({ files: action.payload.files });
        })), catchError((/**
         * @return {?}
         */
        function () { return of(_this.onDeleteFilesSelectionError()); }))); })));
        this.uploadFile$ = this.actions$
            .pipe(ofType(FileManagerActionTypes.UPLOAD_FILE), switchMap((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return _this.uploadFile(action.payload.files[0])
            .pipe(map((/**
         * @param {?} result
         * @return {?}
         */
        function (result) {
            return new UploadFilesSuccessAction({ files: [result] });
        })), catchError((/**
         * @return {?}
         */
        function () {
            return empty();
        }))); })));
        this.moveFile$ = this.actions$
            .pipe(ofType(TreeActionTypes.TREE_MOVE_NODE), filter((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            return action.payload.sourceOfDroppedData === 'FILE';
        })), switchMap((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return _this.moveFiles([(/** @type {?} */ (action.payload.oldNode))], action.payload.node)
            .pipe(map((/**
         * @param {?} result
         * @return {?}
         */
        function (result) {
            /** @type {?} */
            var folderId = ((/** @type {?} */ (action.payload.oldNode))).folderId;
            return new MoveFilesSuccessAction({ files: result, folderId: folderId });
        })), catchError((/**
         * @return {?}
         */
        function () {
            return of(new MoveFilesErrorAction({ files: [(/** @type {?} */ (action.payload.oldNode))] }));
        }))); })));
        this.filesMoveSuccess$ = this.actions$
            .pipe(ofType(FileManagerActionTypes.MOVE_FILES_SUCCESS), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            _this.onMoveFilesSuccess();
            return new LoadFilesAction({ folderId: action.payload.folderId });
        })));
        this.deleteFileSuccessEffect$ = this.deleteFileSuccess$
            .pipe(map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            _this.filemanagerNotification.send({
                type: 'success',
                title: 'File delete',
                message: action.payload.file.name + " has been deleted"
            });
        })));
        this.uploadError$ = this.actions$
            .pipe(ofType(FileManagerActionTypes.UPLOAD_FILE_ERROR), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            _this.filemanagerNotification.send({
                type: 'alert',
                title: 'File upload',
                message: action.payload.files[0].name + " exists on the server in this directory"
            });
        })));
        this.actions$
            .pipe(ofType(FileManagerActionTypes.CROP_FILE_ERROR))
            .subscribe((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            _this.onCropFileError(action.payload.file);
        }));
        this.actions$
            .pipe(ofType(FileManagerActionTypes.MOVE_FILES_ERROR))
            .subscribe((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            _this.onMoveFilesError();
        }));
    }
    /**
     * @protected
     * @param {?} file
     * @param {?} bounds
     * @return {?}
     */
    FileManagerEffectsService.prototype.cropFile = /**
     * @protected
     * @param {?} file
     * @param {?} bounds
     * @return {?}
     */
    function (file, bounds) {
        return this.fileManagerApiService.cropFile(file.toJSON(), bounds);
    };
    /**
     * @protected
     * @param {?} file
     * @return {?}
     */
    FileManagerEffectsService.prototype.deleteFile = /**
     * @protected
     * @param {?} file
     * @return {?}
     */
    function (file) {
        return this.fileManagerApiService.removeFile(file.toJSON());
    };
    /**
     * @protected
     * @param {?} files
     * @return {?}
     */
    FileManagerEffectsService.prototype.deleteFilesSelection = /**
     * @protected
     * @param {?} files
     * @return {?}
     */
    function (files) {
        return this.fileManagerApiService.removeSelectedFiles(files);
    };
    /**
     * @protected
     * @param {?} folderId
     * @return {?}
     */
    FileManagerEffectsService.prototype.loadFiles = /**
     * @protected
     * @param {?} folderId
     * @return {?}
     */
    function (folderId) {
        return this.fileManagerApiService.loadFiles(folderId);
    };
    /**
     * @protected
     * @param {?} file
     * @return {?}
     */
    FileManagerEffectsService.prototype.uploadFile = /**
     * @protected
     * @param {?} file
     * @return {?}
     */
    function (file) {
        return this.fileManagerApiService.uploadFile(file);
    };
    /**
     * @protected
     * @param {?} files
     * @param {?=} folder
     * @return {?}
     */
    FileManagerEffectsService.prototype.moveFiles = /**
     * @protected
     * @param {?} files
     * @param {?=} folder
     * @return {?}
     */
    function (files, folder) {
        if (folder === void 0) { folder = null; }
        return this.fileManagerApiService.moveFile(files, folder);
    };
    /**
     * @protected
     * @param {?} file
     * @return {?}
     */
    FileManagerEffectsService.prototype.onCropFileError = /**
     * @protected
     * @param {?} file
     * @return {?}
     */
    function (file) {
        this.filemanagerNotification.send({
            type: 'alert',
            title: 'Crop Image',
            message: '[FILEMANAGER] Can not crop file'
        });
    };
    /**
     * @protected
     * @param {?} file
     * @return {?}
     */
    FileManagerEffectsService.prototype.onDeleteFileError = /**
     * @protected
     * @param {?} file
     * @return {?}
     */
    function (file) {
        this.filemanagerNotification.send({
            type: 'error',
            title: 'Delete file',
            message: '[FILEMANAGER] Can not delete file' + file.name
        });
    };
    /**
     * @protected
     * @return {?}
     */
    FileManagerEffectsService.prototype.onDeleteFilesSelectionError = /**
     * @protected
     * @return {?}
     */
    function () {
        this.filemanagerNotification.send({
            type: 'error',
            title: 'Delete selected files',
            message: '[FILEMANAGER] Not all files were deleted'
        });
    };
    /**
     * @protected
     * @param {?} folderId
     * @return {?}
     */
    FileManagerEffectsService.prototype.onLoadFilesError = /**
     * @protected
     * @param {?} folderId
     * @return {?}
     */
    function (folderId) {
        this.filemanagerNotification.send({
            type: 'error',
            title: 'Load files',
            message: '[FILEMANAGER] Can not load files for folder ' + folderId
        });
    };
    /**
     * @protected
     * @return {?}
     */
    FileManagerEffectsService.prototype.onMoveFilesSuccess = /**
     * @protected
     * @return {?}
     */
    function () {
        this.filemanagerNotification.send({
            type: 'success',
            title: 'Move files',
            message: 'File was successfully moved to folder'
        });
    };
    /**
     * @protected
     * @return {?}
     */
    FileManagerEffectsService.prototype.onMoveFilesError = /**
     * @protected
     * @return {?}
     */
    function () {
        this.filemanagerNotification.send({
            type: 'error',
            title: 'Move files',
            message: 'File was not successfully moved to new folder'
        });
    };
    FileManagerEffectsService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    FileManagerEffectsService.ctorParameters = function () { return [
        { type: Actions },
        { type: FilemanagerNotifications },
        { type: FileManagerApiService }
    ]; };
    __decorate([
        Effect(),
        __metadata("design:type", Object)
    ], FileManagerEffectsService.prototype, "loadFiles$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Object)
    ], FileManagerEffectsService.prototype, "cropFile$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Object)
    ], FileManagerEffectsService.prototype, "deleteFile$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Object)
    ], FileManagerEffectsService.prototype, "deleteFilesSelection$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Object)
    ], FileManagerEffectsService.prototype, "uploadFile$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Object)
    ], FileManagerEffectsService.prototype, "moveFile$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Object)
    ], FileManagerEffectsService.prototype, "filesMoveSuccess$", void 0);
    __decorate([
        Effect({ dispatch: false }),
        __metadata("design:type", Object)
    ], FileManagerEffectsService.prototype, "deleteFileSuccessEffect$", void 0);
    return FileManagerEffectsService;
}());
if (false) {
    /** @type {?} */
    FileManagerEffectsService.prototype.cropFileSuccess$;
    /** @type {?} */
    FileManagerEffectsService.prototype.deleteFileSuccess$;
    /** @type {?} */
    FileManagerEffectsService.prototype.loadFiles$;
    /** @type {?} */
    FileManagerEffectsService.prototype.cropFile$;
    /** @type {?} */
    FileManagerEffectsService.prototype.deleteFile$;
    /** @type {?} */
    FileManagerEffectsService.prototype.deleteFilesSelection$;
    /** @type {?} */
    FileManagerEffectsService.prototype.uploadFile$;
    /** @type {?} */
    FileManagerEffectsService.prototype.moveFile$;
    /** @type {?} */
    FileManagerEffectsService.prototype.filesMoveSuccess$;
    /** @type {?} */
    FileManagerEffectsService.prototype.deleteFileSuccessEffect$;
    /** @type {?} */
    FileManagerEffectsService.prototype.uploadError$;
    /**
     * @type {?}
     * @private
     */
    FileManagerEffectsService.prototype.actions$;
    /**
     * @type {?}
     * @private
     */
    FileManagerEffectsService.prototype.filemanagerNotification;
    /**
     * @type {?}
     * @private
     */
    FileManagerEffectsService.prototype.fileManagerApiService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IFileManagerApi() { }
if (false) {
    /**
     * @param {?} node
     * @param {?} parentNodeId
     * @return {?}
     */
    IFileManagerApi.prototype.add = function (node, parentNodeId) { };
    /**
     * @param {?} nodeId
     * @return {?}
     */
    IFileManagerApi.prototype.load = function (nodeId) { };
    /**
     * @param {?} srcNode
     * @param {?} targetNode
     * @return {?}
     */
    IFileManagerApi.prototype.move = function (srcNode, targetNode) { };
    /**
     * @param {?} node
     * @return {?}
     */
    IFileManagerApi.prototype.update = function (node) { };
    /**
     * @param {?} nodeId
     * @return {?}
     */
    IFileManagerApi.prototype.remove = function (nodeId) { };
    /**
     * @param {?} file
     * @param {?} bounds
     * @return {?}
     */
    IFileManagerApi.prototype.cropFile = function (file, bounds) { };
    /**
     * @param {?} nodeId
     * @return {?}
     */
    IFileManagerApi.prototype.loadFiles = function (nodeId) { };
    /**
     * @param {?} file
     * @return {?}
     */
    IFileManagerApi.prototype.removeFile = function (file) { };
    /**
     * @param {?} selectedFiles
     * @return {?}
     */
    IFileManagerApi.prototype.removeSelectedFiles = function (selectedFiles) { };
    /**
     * @param {?} file
     * @return {?}
     */
    IFileManagerApi.prototype.uploadFile = function (file) { };
    /**
     * @param {?} files
     * @param {?} node
     * @return {?}
     */
    IFileManagerApi.prototype.moveFile = function (files, node) { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileTypeFilterComponent = /** @class */ (function () {
    function FileTypeFilterComponent(fileTypeFilter) {
        var _this = this;
        this.fileTypeFilter = fileTypeFilter;
        this.typeFilterList = [];
        this.selectedType = null;
        this.fileTypeFilter.filter$
            .subscribe((/**
         * @param {?} type
         * @return {?}
         */
        function (type) {
            _this.selectedType = type;
        }));
    }
    /**
     * @return {?}
     */
    FileTypeFilterComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** init file type filter **/
        this.typeFilterList
            .filter((/**
         * @param {?} type
         * @return {?}
         */
        function (type) {
            return type.defaultSelected;
        }))
            .forEach((/**
         * @param {?} type
         * @return {?}
         */
        function (type) {
            _this.fileTypeFilter.setValue(type);
        }));
    };
    /**
     * Set current filter and fire event
     * @param type
     */
    /**
     * Set current filter and fire event
     * @param {?} type
     * @return {?}
     */
    FileTypeFilterComponent.prototype.setFilterType = /**
     * Set current filter and fire event
     * @param {?} type
     * @return {?}
     */
    function (type) {
        this.fileTypeFilter.setValue(type);
    };
    FileTypeFilterComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ri-file-type-filter',
                    template: "<div class=\"btn-group\">\n  <button *ngFor=\"let type of typeFilterList\" class=\"btn btn-secondary\" [ngClass]=\"{'active': type === selectedType}\"\n          (click)=\"setFilterType(type)\">\n    <i class=\"{{type.iconCls}}\"></i>\n  </button>\n</div>\n"
                }] }
    ];
    /** @nocollapse */
    FileTypeFilterComponent.ctorParameters = function () { return [
        { type: FileTypeFilterService }
    ]; };
    FileTypeFilterComponent.propDecorators = {
        typeFilterList: [{ type: Input }]
    };
    return FileTypeFilterComponent;
}());
if (false) {
    /** @type {?} */
    FileTypeFilterComponent.prototype.typeFilterList;
    /** @type {?} */
    FileTypeFilterComponent.prototype.selectedType;
    /**
     * @type {?}
     * @private
     */
    FileTypeFilterComponent.prototype.fileTypeFilter;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IAddFolder() { }
if (false) {
    /** @type {?} */
    IAddFolder.prototype.name;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IFileTypeFilter() { }
if (false) {
    /** @type {?} */
    IFileTypeFilter.prototype.name;
    /** @type {?} */
    IFileTypeFilter.prototype.mimes;
    /** @type {?} */
    IFileTypeFilter.prototype.iconCls;
    /** @type {?|undefined} */
    IFileTypeFilter.prototype.text;
    /** @type {?|undefined} */
    IFileTypeFilter.prototype.defaultSelected;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IToolbarEvent() { }
if (false) {
    /** @type {?} */
    IToolbarEvent.prototype.name;
    /** @type {?|undefined} */
    IToolbarEvent.prototype.value;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var IUploadItemEvent = /** @class */ (function () {
    function IUploadItemEvent() {
    }
    return IUploadItemEvent;
}());
if (false) {
    /** @type {?} */
    IUploadItemEvent.prototype.name;
    /** @type {?} */
    IUploadItemEvent.prototype.response;
    /** @type {?} */
    IUploadItemEvent.prototype.status;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var Button = {
    ADD_FOLDER: 'ADD_FOLDER',
    CHOOSE_SELECTION: 'CHOOSE_SELECTION',
    DELETE_SELECTION: 'DELETE_SELECTION',
    INVERSE_SELECTION: 'INVERSE_SELECTION',
    REFRESH_FILES_LIST: 'REFRESH_FILES_LIST',
    SELECT_ALL: 'SELECT_ALL',
    UNSELECT_ALL: 'UNSELECT_ALL',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToolbarEventModel = /** @class */ (function () {
    function ToolbarEventModel(name, value) {
        if (value === void 0) { value = null; }
        this.name = name;
        this.value = value;
    }
    return ToolbarEventModel;
}());
if (false) {
    /** @type {?} */
    ToolbarEventModel.prototype.name;
    /** @type {?} */
    ToolbarEventModel.prototype.value;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SearchFileComponent = /** @class */ (function () {
    function SearchFileComponent(searchFilterService, filemanagerTranslations) {
        this.searchFilterService = searchFilterService;
        this.filemanagerTranslations = filemanagerTranslations;
        this.searchField = new FormControl();
    }
    /**
     * @return {?}
     */
    SearchFileComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.searchField.valueChanges
            .pipe(debounceTime(250))
            .subscribe((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return _this.searchFilterService.setValue(value); }));
    };
    SearchFileComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ri-search-file',
                    template: "<div class=\"input-group\">\n  <input [formControl]=\"searchField\" type=\"text\" class=\"form-control\"\n         placeholder=\"{{filemanagerTranslations.RI_FM_LBL_SEARCH_FOR}}\">\n  <span class=\"input-group-append\">\n      <button (click)=\"searchField.reset('')\" class=\"btn btn-secondary\" type=\"button\">\n          <i class=\"fa fa-times\"></i>\n      </button>\n  </span>\n</div>\n"
                }] }
    ];
    /** @nocollapse */
    SearchFileComponent.ctorParameters = function () { return [
        { type: SearchFilterService },
        { type: undefined, decorators: [{ type: Inject, args: [FILEMANAGER_TRANSLATION_TOKEN,] }] }
    ]; };
    return SearchFileComponent;
}());
if (false) {
    /** @type {?} */
    SearchFileComponent.prototype.searchField;
    /**
     * @type {?}
     * @private
     */
    SearchFileComponent.prototype.searchFilterService;
    /** @type {?} */
    SearchFileComponent.prototype.filemanagerTranslations;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var /**
 * @abstract
 */
AbstractButtonClass = /** @class */ (function () {
    function AbstractButtonClass(data) {
        this.symbol = data.symbol;
        this.name = data.name;
        this.label = data.label;
        this.icon = data.icon;
        this.iconCssClass = data.iconCssClass;
        this.disabled = data.disabled;
    }
    return AbstractButtonClass;
}());
if (false) {
    /** @type {?} */
    AbstractButtonClass.prototype.symbol;
    /** @type {?} */
    AbstractButtonClass.prototype.name;
    /** @type {?} */
    AbstractButtonClass.prototype.label;
    /** @type {?} */
    AbstractButtonClass.prototype.icon;
    /** @type {?} */
    AbstractButtonClass.prototype.iconCssClass;
    /** @type {?} */
    AbstractButtonClass.prototype.disabled;
    /**
     * @abstract
     * @return {?}
     */
    AbstractButtonClass.prototype.isDivider = function () { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ButtonClass = /** @class */ (function (_super) {
    __extends(ButtonClass, _super);
    function ButtonClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @return {?}
     */
    ButtonClass.prototype.isDivider = /**
     * @return {?}
     */
    function () {
        return false;
    };
    return ButtonClass;
}(AbstractButtonClass));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ButtonDividerClass = /** @class */ (function (_super) {
    __extends(ButtonDividerClass, _super);
    function ButtonDividerClass() {
        return _super.call(this, {
            symbol: '',
            name: '',
            label: false,
            icon: false,
            iconCssClass: ''
        }) || this;
    }
    /**
     * @return {?}
     */
    ButtonDividerClass.prototype.isDivider = /**
     * @return {?}
     */
    function () {
        return true;
    };
    return ButtonDividerClass;
}(AbstractButtonClass));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SelectionComponent = /** @class */ (function () {
    function SelectionComponent(configuration, currentDirectoryFilesService, filemanagerTranslations) {
        this.configuration = configuration;
        this.currentDirectoryFilesService = currentDirectoryFilesService;
        this.filemanagerTranslations = filemanagerTranslations;
        this.onMenuButtonClick = new EventEmitter();
        this.selectAllButton = new ButtonClass({
            symbol: Button.SELECT_ALL,
            name: this.filemanagerTranslations.RI_FM_LBL_SELECT_ALL,
            label: true,
            icon: true,
            iconCssClass: 'fa fa-check-square-o'
        });
        this.unselectAllButton = new ButtonClass({
            symbol: Button.UNSELECT_ALL,
            name: this.filemanagerTranslations.RI_FM_LBL_UNSELECT_ALL,
            label: true,
            icon: true,
            iconCssClass: 'fa fa-square-o'
        });
        this.inverseSelectionButton = new ButtonClass({
            symbol: Button.INVERSE_SELECTION,
            name: this.filemanagerTranslations.RI_FM_LBL_INVERSE_SELECTION,
            label: true,
            icon: true,
            iconCssClass: 'fa fa-check-square'
        });
        this.deleteSelectionButton = new ButtonClass({
            symbol: Button.DELETE_SELECTION,
            name: this.filemanagerTranslations.RI_FM_LBL_DELETE_SELECTION,
            label: true,
            icon: true,
            iconCssClass: 'fa fa-trash'
        });
        this.chooseSelectionButton = new ButtonClass({
            symbol: Button.CHOOSE_SELECTION,
            name: this.filemanagerTranslations.RI_FM_LBL_CHOOSE_SELECTION,
            label: true,
            icon: true,
            iconCssClass: 'fa fa-image'
        });
        this.selectButtonsList = this.createBasicButtons();
        this.initListenOnLoadFiles();
    }
    /**
     * @return {?}
     */
    SelectionComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.onLoadFilesSubscriber.unsubscribe();
    };
    /**
     * Initialize listener on load files
     */
    /**
     * Initialize listener on load files
     * @return {?}
     */
    SelectionComponent.prototype.initListenOnLoadFiles = /**
     * Initialize listener on load files
     * @return {?}
     */
    function () {
        var _this = this;
        this.onLoadFilesSubscriber = combineLatest(this.currentDirectoryFilesService.currentDirectoryFileIds$, this.currentDirectoryFilesService.selectedFiles$)
            .pipe(distinctUntilChanged())
            .subscribe((/**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            /** @type {?} */
            var numberOfFiles = data[0].length;
            /** @type {?} */
            var numberOfSelectedFiles = data[1].length;
            _this.disableAllButtons();
            if (numberOfFiles > 0) {
                if (numberOfSelectedFiles > 0) {
                    _this.enableAllButtons();
                }
                else {
                    _this.enableSelectAllButton();
                }
            }
        }));
    };
    /**
     * @param {?} button
     * @return {?}
     */
    SelectionComponent.prototype.onSelectDropdownClick = /**
     * @param {?} button
     * @return {?}
     */
    function (button) {
        /** @type {?} */
        var event = new ToolbarEventModel(button.symbol);
        this.onMenuButtonClick.emit(event);
    };
    /**
     * Disable all dropdown buttons and main button
     */
    /**
     * Disable all dropdown buttons and main button
     * @private
     * @return {?}
     */
    SelectionComponent.prototype.disableAllButtons = /**
     * Disable all dropdown buttons and main button
     * @private
     * @return {?}
     */
    function () {
        this.selectAllButton.disabled = true;
        this.selectButtonsList
            .filter((/**
         * @param {?} button
         * @return {?}
         */
        function (button) {
            return !button.isDivider();
        }))
            .forEach((/**
         * @param {?} button
         * @return {?}
         */
        function (button) {
            button.disabled = true;
        }));
    };
    /**
     * Enable all dropdown buttons and main button
     */
    /**
     * Enable all dropdown buttons and main button
     * @private
     * @return {?}
     */
    SelectionComponent.prototype.enableAllButtons = /**
     * Enable all dropdown buttons and main button
     * @private
     * @return {?}
     */
    function () {
        this.selectAllButton.disabled = false;
        this.selectButtonsList
            .forEach((/**
         * @param {?} button
         * @return {?}
         */
        function (button) {
            button.disabled = false;
        }));
    };
    /**
     * Create list of buttons
     */
    /**
     * Create list of buttons
     * @private
     * @return {?}
     */
    SelectionComponent.prototype.createBasicButtons = /**
     * Create list of buttons
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var buttons = [
            this.selectAllButton,
            this.unselectAllButton,
            this.inverseSelectionButton,
            new ButtonDividerClass(),
            this.deleteSelectionButton,
        ];
        if (this.configuration.allowChooseMultipleFiles) {
            buttons.push(new ButtonDividerClass());
            buttons.push(this.chooseSelectionButton);
        }
        return buttons;
    };
    /**
     * Enable only select button
     */
    /**
     * Enable only select button
     * @private
     * @return {?}
     */
    SelectionComponent.prototype.enableSelectAllButton = /**
     * Enable only select button
     * @private
     * @return {?}
     */
    function () {
        this.selectAllButton.disabled = false;
        this.inverseSelectionButton.disabled = false;
    };
    SelectionComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ri-selection-dropdown',
                    template: "<ri-dropdown *ngIf=\"configuration.isMultiSelection\" [mainButton]=\"selectAllButton\" [buttons]=\"selectButtonsList\"\n             (onClick)=\"onSelectDropdownClick($event)\"></ri-dropdown>\n"
                }] }
    ];
    /** @nocollapse */
    SelectionComponent.ctorParameters = function () { return [
        { type: FileManagerConfiguration },
        { type: CurrentDirectoryFilesService },
        { type: undefined, decorators: [{ type: Inject, args: [FILEMANAGER_TRANSLATION_TOKEN,] }] }
    ]; };
    SelectionComponent.propDecorators = {
        onMenuButtonClick: [{ type: Output }]
    };
    return SelectionComponent;
}());
if (false) {
    /** @type {?} */
    SelectionComponent.prototype.onMenuButtonClick;
    /** @type {?} */
    SelectionComponent.prototype.selectButtonsList;
    /** @type {?} */
    SelectionComponent.prototype.selectAllButton;
    /**
     * @type {?}
     * @private
     */
    SelectionComponent.prototype.unselectAllButton;
    /**
     * @type {?}
     * @private
     */
    SelectionComponent.prototype.inverseSelectionButton;
    /**
     * @type {?}
     * @private
     */
    SelectionComponent.prototype.deleteSelectionButton;
    /**
     * @type {?}
     * @private
     */
    SelectionComponent.prototype.chooseSelectionButton;
    /**
     * @type {?}
     * @private
     */
    SelectionComponent.prototype.onLoadFilesSubscriber;
    /** @type {?} */
    SelectionComponent.prototype.configuration;
    /**
     * @type {?}
     * @private
     */
    SelectionComponent.prototype.currentDirectoryFilesService;
    /** @type {?} */
    SelectionComponent.prototype.filemanagerTranslations;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToolbarComponent = /** @class */ (function () {
    function ToolbarComponent(configuration, fileManagerUploader, store) {
        var _this = this;
        this.configuration = configuration;
        this.fileManagerUploader = fileManagerUploader;
        this.store = store;
        this.onAddFolderClick = new EventEmitter();
        this.onUpload = new EventEmitter();
        this.onMenuButtonClick = new EventEmitter();
        this.fileManagerUploader.clear();
        this.fileManagerUploader.uploader.onCompleteAll = (/**
         * @return {?}
         */
        function () {
            _this.onUpload.emit(_this.currentFolderId || '');
        });
        this.fileManagerUploader.uploader.onCompleteItem = (/**
         * @param {?} item
         * @param {?} response
         * @param {?} status
         * @param {?} headers
         * @return {?}
         */
        function (item, response, status, headers) {
            if (status === 200) {
                _this.store.dispatch(new UploadFilesAction({ files: [JSON.parse(response)] }));
            }
            else {
                _this.store.dispatch(new UploadFilesErrorAction({ files: JSON.parse(response) }));
            }
        });
    }
    /**
     * @return {?}
     */
    ToolbarComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        this.fileManagerUploader.setDirectoryId(this.currentFolderId || '');
    };
    /**
     * @return {?}
     */
    ToolbarComponent.prototype.addFolder = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var event = new ToolbarEventModel(Button.ADD_FOLDER, '');
        this.onAddFolderClick.emit(event);
    };
    /**
     * @return {?}
     */
    ToolbarComponent.prototype.onRefreshFilesList = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var event = new ToolbarEventModel(Button.REFRESH_FILES_LIST);
        this.onMenuButtonClick.emit(event);
    };
    ToolbarComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ri-toolbar',
                    template: "<div class=\"toolbar row\">\n  <div class=\"col-md-6\">\n    <div class=\"btn-group\">\n      <button class=\"btn btn-secondary\" (click)=\"addFolder()\">\n        <i class=\"fa fa-plus\"></i>\n        <i class=\"fa fa-folder-o\"></i>\n      </button>\n      <span class=\"hidden-input-file\">\n        <input #fileInput type=\"file\" ng2FileSelect [uploader]=\"fileManagerUploader.uploader\" multiple/>\n      </span>\n      <button class=\"btn btn-secondary\" (click)=\"fileInput.click()\">\n        <i class=\"fa fa-plus\"></i>\n        <i class=\"fa fa-file-o\"></i>\n      </button>\n    </div>\n    <ri-selection-dropdown (onMenuButtonClick)=\"onMenuButtonClick.next($event)\"></ri-selection-dropdown>\n    <div class=\"btn-group\">\n      <button class=\"btn btn-secondary\" (click)=\"onRefreshFilesList()\">\n        <i class=\"fa fa-refresh\"></i>\n      </button>\n    </div>\n  </div>\n  <div class=\"col-md-3\">\n    <ri-file-type-filter [typeFilterList]=\"configuration.fileTypesFilter\"></ri-file-type-filter>\n  </div>\n  <div class=\"col-md-3\">\n    <ri-search-file></ri-search-file>\n  </div>\n</div>\n",
                    styles: [".toolbar{margin-bottom:10px}.btn{height:34px}.btn-file{position:relative;overflow:hidden}.hidden-input-file{visibility:hidden;position:absolute;overflow:hidden;width:0;height:0;border:none;margin:0;padding:0}.btn-group,ri-selection-dropdown{padding:0 2px 0 0}"]
                }] }
    ];
    /** @nocollapse */
    ToolbarComponent.ctorParameters = function () { return [
        { type: FileManagerConfiguration },
        { type: FileManagerUploader },
        { type: Store }
    ]; };
    ToolbarComponent.propDecorators = {
        currentFolderId: [{ type: Input }],
        onAddFolderClick: [{ type: Output }],
        onUpload: [{ type: Output }],
        onMenuButtonClick: [{ type: Output }]
    };
    return ToolbarComponent;
}());
if (false) {
    /** @type {?} */
    ToolbarComponent.prototype.currentFolderId;
    /** @type {?} */
    ToolbarComponent.prototype.onAddFolderClick;
    /** @type {?} */
    ToolbarComponent.prototype.onUpload;
    /** @type {?} */
    ToolbarComponent.prototype.onMenuButtonClick;
    /** @type {?} */
    ToolbarComponent.prototype.configuration;
    /** @type {?} */
    ToolbarComponent.prototype.fileManagerUploader;
    /**
     * @type {?}
     * @private
     */
    ToolbarComponent.prototype.store;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileManagerComponent = /** @class */ (function () {
    function FileManagerComponent(store, nodeDispatcherService, treeService, configuration, fileManagerEffects, filemanagerNotifications, currentDirectoryFilesService, treeInitializerService) {
        var _this = this;
        this.store = store;
        this.nodeDispatcherService = nodeDispatcherService;
        this.treeService = treeService;
        this.configuration = configuration;
        this.fileManagerEffects = fileManagerEffects;
        this.filemanagerNotifications = filemanagerNotifications;
        this.currentDirectoryFilesService = currentDirectoryFilesService;
        this.treeInitializerService = treeInitializerService;
        this.onSingleFileSelect = new EventEmitter();
        this.treeConfiguration = {
            showAddButton: false,
            disableMoveNodes: false,
            treeId: FILEMANAGER_TREE_NAME,
            dragZone: FILEMANAGER_TREE_NAME,
            dropZone: [FILEMANAGER_TREE_NAME]
        };
        /**
         * UNSED *
         */
        this.contextMenu = [];
        this.currentSelectedFilesIds = [];
        this.currentSelectedFiles = [];
        this.isPreviewMode = false;
        this.isCropMode = false;
        this.subscription = new Subscription();
        this.menu = configuration.contextMenuItems;
        this.subscription.add(this.currentDirectoryFilesService.selectedFiles$
            .subscribe((/**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            _this.currentSelectedFilesIds = data;
        })));
        this.subscription.add(combineLatest(this.currentDirectoryFilesService.selectedFiles$, this.currentDirectoryFilesService.entities$)
            .subscribe((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b = __read(_a, 2), ids = _b[0], entities = _b[1];
            _this.currentSelectedFiles = ids.map((/**
             * @param {?} id
             * @return {?}
             */
            function (id) { return entities[id]; }));
        })));
    }
    /**
     * @return {?}
     */
    FileManagerComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.subscription.unsubscribe();
    };
    /**
     * @return {?}
     */
    FileManagerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.treeModel = this.treeInitializerService.init(this.treeConfiguration, this.treeService);
        this.subscription.add(this.treeModel.currentSelectedNode$
            .subscribe((/**
         * @param {?} node
         * @return {?}
         */
        function (node) { return _this.currentSelectedFolder = node; })));
        /*** START - init files ***/
        this.files$ = this.currentDirectoryFilesService.files$;
        this.filteredFiles$ = this.currentDirectoryFilesService.filteredFiles$;
        this.selectedFiles$ = this.currentDirectoryFilesService.selectedFiles$;
        this.subscription.add(this.treeModel.currentSelectedNode$
            .subscribe((/**
         * @param {?} node
         * @return {?}
         */
        function (node) {
            _this.loadFiles(node ? node.id : '');
        })));
        /*** END - init files ***/
        this.subscription.add(this.fileManagerEffects.cropFileSuccess$
            .subscribe((/**
         * @return {?}
         */
        function () {
            _this.closeModal();
        })));
    };
    Object.defineProperty(FileManagerComponent.prototype, "currentSelectedFolderId", {
        get: /**
         * @return {?}
         */
        function () {
            return this.currentSelectedFolder ? this.currentSelectedFolder.id : null;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    FileManagerComponent.prototype.onAddFolder = /**
     * @return {?}
     */
    function () {
        this.treeComponent.onAdd();
    };
    /***********************************************************************
     * FILE EVENTS
     **********************************************************************/
    /**
     * Run when all files are uploaded
     */
    /***********************************************************************
       * FILE EVENTS
       **********************************************************************/
    /**
     * Run when all files are uploaded
     * @param {?} folderId
     * @return {?}
     */
    FileManagerComponent.prototype.onUpload = /***********************************************************************
       * FILE EVENTS
       **********************************************************************/
    /**
     * Run when all files are uploaded
     * @param {?} folderId
     * @return {?}
     */
    function (folderId) {
        this.filemanagerNotifications.send({
            type: 'success',
            title: 'File upload',
            message: 'Upload complete',
        });
    };
    /**
     * @param {?} fileEventData
     * @return {?}
     */
    FileManagerComponent.prototype.onPreviewFile = /**
     * @param {?} fileEventData
     * @return {?}
     */
    function (fileEventData) {
        this.isPreviewMode = true;
        this.currentSelectedFile = fileEventData.file;
    };
    /**
     * @param {?} fileEventData
     * @return {?}
     */
    FileManagerComponent.prototype.onOpenCropFileEditor = /**
     * @param {?} fileEventData
     * @return {?}
     */
    function (fileEventData) {
        this.isCropMode = true;
        this.currentSelectedFile = fileEventData.file;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    FileManagerComponent.prototype.onSelectFile = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.onSingleFileSelect.next(event.getSelectData());
    };
    /***********************************************************************
     * TOOLBAR EVENTS
     **********************************************************************/
    /**
     * ********************************************************************
     * TOOLBAR EVENTS
     * ********************************************************************
     * @param {?} event
     * @return {?}
     */
    FileManagerComponent.prototype.onMenuButtonClick = /**
     * ********************************************************************
     * TOOLBAR EVENTS
     * ********************************************************************
     * @param {?} event
     * @return {?}
     */
    function (event) {
        switch (event.name) {
            case Button.CHOOSE_SELECTION:
                this.store.dispatch(new ChooseFilesAction({ files: this.currentSelectedFiles }));
                break;
            case Button.DELETE_SELECTION:
                this.store.dispatch(new DeleteSelectedFilesAction({ files: this.currentSelectedFilesIds }));
                break;
            case Button.SELECT_ALL:
                this.store.dispatch(new SelectAllFilesAction());
                break;
            case Button.UNSELECT_ALL:
                this.store.dispatch(new UnSelectAllFilesAction());
                break;
            case Button.INVERSE_SELECTION:
                this.store.dispatch(new InverseFilesSelectionAction());
                break;
            case Button.REFRESH_FILES_LIST:
                this.reloadFiles();
                break;
        }
    };
    /***********************************************************************
     * OTHER FUNCTIONS
     **********************************************************************/
    /**
     * ********************************************************************
     * OTHER FUNCTIONS
     * ********************************************************************
     * @param {?} event
     * @return {?}
     */
    FileManagerComponent.prototype.keyEvents = /**
     * ********************************************************************
     * OTHER FUNCTIONS
     * ********************************************************************
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (this.isPreviewMode || this.isCropMode) {
            if (event.keyCode === 27) {
                this.closeModal();
            }
        }
    };
    /**
     * @return {?}
     */
    FileManagerComponent.prototype.closeModal = /**
     * @return {?}
     */
    function () {
        this.isPreviewMode = false;
        this.isCropMode = false;
    };
    /**
     * @private
     * @param {?} folderId
     * @return {?}
     */
    FileManagerComponent.prototype.loadFiles = /**
     * @private
     * @param {?} folderId
     * @return {?}
     */
    function (folderId) {
        this.store.dispatch(new LoadFilesAction({ folderId: folderId || '' }));
    };
    /**
     * @private
     * @return {?}
     */
    FileManagerComponent.prototype.reloadFiles = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var id = this.currentSelectedFolder ? this.currentSelectedFolder.id : '';
        this.loadFiles(id);
    };
    FileManagerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ri-filemanager',
                    providers: [NodeService],
                    template: "<div class=\"filemanager-container\">\n  <div class=\"fm-header\">\n    <ri-toolbar\n        #toolbar\n        [currentFolderId]=\"currentSelectedFolderId\"\n        (onAddFolderClick)=\"onAddFolder()\"\n        (onUpload)=\"onUpload($event)\"\n        (onMenuButtonClick)=\"onMenuButtonClick($event)\"\n    ></ri-toolbar>\n  </div>\n  <div class=\"fm-main-box\">\n    <div class=\"folders-box\">\n      <ri-tree [treeModel]=\"treeModel\"></ri-tree>\n    </div>\n    <div class=\"files-box\">\n      <ri-tree-parents-list [treeModel]=\"treeModel\"></ri-tree-parents-list>\n      <ri-files-list [files]=\"filteredFiles$ | async\"\n                     [selectedFiles]=\"selectedFiles$ | async\"\n                     (onPreviewFile)=\"onPreviewFile($event)\"\n                     (onCropFile)=\"onOpenCropFileEditor($event)\"\n                     (onSelectFile)=\"onSelectFile($event)\"\n      ></ri-files-list>\n    </div>\n  </div>\n  <div *ngIf=\"isPreviewMode || isCropMode\" class=\"backdrop\">\n    <div class=\"modal-view\">\n      <div class=\"modal-close\">\n        <i class=\"fa fa-2x fa-times\" (click)=\"closeModal()\"></i>\n      </div>\n      <ri-file-preview *ngIf=\"isPreviewMode\" [files]=\"filteredFiles$ | async\"\n                       [file]=\"currentSelectedFile\"></ri-file-preview>\n      <crop-image *ngIf=\"isCropMode\" [file]=\"currentSelectedFile\"></crop-image>\n    </div>\n  </div>\n</div>\n",
                    styles: [".filemanager-container{width:990px;height:700px}.filemanager-container .tree .dropdown{position:relative}.filemanager-container .tree .dropdown-menu{position:fixed!important}.fm-main-box{position:relative;height:100%}.fm-main-box .folders-box{display:block;position:absolute;top:0;bottom:0;width:300px;overflow:hidden;overflow-y:auto}.fm-main-box .files-box{display:block;position:absolute;left:300px;top:0;bottom:0;overflow:hidden;overflow-y:auto}.fm-main-box .files-box ri-tree-parents-list{margin:0 0 10px 20px;display:block}.backdrop{position:fixed;left:0;right:0;top:0;bottom:0;background-color:rgba(0,0,0,.7);z-index:1000}.modal-view{margin:50px auto;max-width:600px}.modal-view .modal-close{text-align:right;margin:5px 0;color:#fff}.modal-view .modal-close .fa{cursor:pointer}"]
                }] }
    ];
    /** @nocollapse */
    FileManagerComponent.ctorParameters = function () { return [
        { type: Store },
        { type: NodeDispatcherService },
        { type: FileManagerApiService },
        { type: FileManagerConfiguration },
        { type: FileManagerEffectsService },
        { type: FilemanagerNotifications },
        { type: CurrentDirectoryFilesService },
        { type: TreeInitializerService }
    ]; };
    FileManagerComponent.propDecorators = {
        onSingleFileSelect: [{ type: Output }],
        treeComponent: [{ type: ViewChild, args: [TreeComponent, { static: true },] }],
        filesList: [{ type: ViewChild, args: [FilesListComponent, { static: true },] }],
        keyEvents: [{ type: HostListener, args: ['window:keydown', ['$event'],] }]
    };
    return FileManagerComponent;
}());
if (false) {
    /** @type {?} */
    FileManagerComponent.prototype.onSingleFileSelect;
    /** @type {?} */
    FileManagerComponent.prototype.treeComponent;
    /** @type {?} */
    FileManagerComponent.prototype.filesList;
    /**
     * List of files for current selected directory
     * @type {?}
     * @private
     */
    FileManagerComponent.prototype.files$;
    /** @type {?} */
    FileManagerComponent.prototype.filteredFiles$;
    /** @type {?} */
    FileManagerComponent.prototype.selectedFiles$;
    /** @type {?} */
    FileManagerComponent.prototype.folders;
    /** @type {?} */
    FileManagerComponent.prototype.treeConfiguration;
    /** @type {?} */
    FileManagerComponent.prototype.treeModel;
    /**
     * UNSED *
     * @type {?}
     */
    FileManagerComponent.prototype.contextMenu;
    /** @type {?} */
    FileManagerComponent.prototype.currentSelectedFile;
    /** @type {?} */
    FileManagerComponent.prototype.currentSelectedFilesIds;
    /** @type {?} */
    FileManagerComponent.prototype.currentSelectedFiles;
    /** @type {?} */
    FileManagerComponent.prototype.isPreviewMode;
    /** @type {?} */
    FileManagerComponent.prototype.isCropMode;
    /**
     * List of context menu
     * @type {?}
     */
    FileManagerComponent.prototype.menu;
    /**
     * @type {?}
     * @protected
     */
    FileManagerComponent.prototype.currentSelectedFolder;
    /**
     * @type {?}
     * @private
     */
    FileManagerComponent.prototype.subscription;
    /**
     * @type {?}
     * @private
     */
    FileManagerComponent.prototype.store;
    /**
     * @type {?}
     * @private
     */
    FileManagerComponent.prototype.nodeDispatcherService;
    /**
     * @type {?}
     * @private
     */
    FileManagerComponent.prototype.treeService;
    /**
     * @type {?}
     * @private
     */
    FileManagerComponent.prototype.configuration;
    /**
     * @type {?}
     * @private
     */
    FileManagerComponent.prototype.fileManagerEffects;
    /**
     * @type {?}
     * @private
     */
    FileManagerComponent.prototype.filemanagerNotifications;
    /**
     * @type {?}
     * @private
     */
    FileManagerComponent.prototype.currentDirectoryFilesService;
    /**
     * @type {?}
     * @private
     */
    FileManagerComponent.prototype.treeInitializerService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FileManagerModule = /** @class */ (function () {
    function FileManagerModule() {
    }
    /**
     * @param {?} config
     * @param {?=} apiProvider
     * @return {?}
     */
    FileManagerModule.forRoot = /**
     * @param {?} config
     * @param {?=} apiProvider
     * @return {?}
     */
    function (config, apiProvider) {
        if (apiProvider === void 0) { apiProvider = null; }
        return {
            ngModule: FileManagerModule,
            providers: [
                CurrentDirectoryFilesService,
                FileManagerApiService,
                FileManagerBackendApiService,
                FileManagerConfiguration,
                FileManagerEffectsService,
                FilemanagerNotifications,
                FileManagerUploader,
                FileTypeFilterService,
                ImageDataConverter,
                SearchFilterService,
                TreeService,
                { provide: 'fileManagerConfiguration', useValue: config },
                apiProvider ? apiProvider : FileManagerApiService
            ]
        };
    };
    /**
     * @param {?} config
     * @param {?=} apiProvider
     * @return {?}
     */
    FileManagerModule.forChild = /**
     * @param {?} config
     * @param {?=} apiProvider
     * @return {?}
     */
    function (config, apiProvider) {
        if (apiProvider === void 0) { apiProvider = null; }
        return {
            ngModule: FileManagerModule,
            providers: [
                CurrentDirectoryFilesService,
                FileManagerApiService,
                FileManagerBackendApiService,
                FileManagerConfiguration,
                FileManagerEffectsService,
                FilemanagerNotifications,
                FileManagerUploader,
                FileTypeFilterService,
                ImageDataConverter,
                SearchFilterService,
                TreeService,
                { provide: 'fileManagerConfiguration', useValue: config },
                apiProvider ? apiProvider : FileManagerApiService
            ]
        };
    };
    FileManagerModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        ConfirmationPopoverModule,
                        EffectsModule.forFeature([FileManagerEffectsService]),
                        FormsModule,
                        FileUploadModule,
                        HttpClientModule,
                        ImageCropperModule,
                        ReactiveFormsModule,
                        StoreModule.forFeature('files', fileManagerReducer),
                        TreeModule
                    ],
                    declarations: [
                        FileManagerComponent,
                        FileComponent,
                        FileTypeFilterComponent,
                        ToolbarComponent,
                        FilesListComponent,
                        DropdownComponent,
                        PreviewComponent,
                        CropComponent,
                        SearchFileComponent,
                        SelectionComponent
                    ],
                    entryComponents: [
                        ImageCropperComponent
                    ],
                    exports: [FileManagerComponent],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];
    return FileManagerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { AbstractFileManagerApiService, Button, ChooseFilesAction, CropComponent, CropFileAction, CropFileErrorAction, CropFileSuccessAction, CurrentDirectoryFilesService, DeleteFileAction, DeleteFileSuccessAction, DeleteSelectedFilesAction, DeleteSelectedFilesSuccessAction, DropdownComponent, ExtendedFileUploader, FILEMANAGER_TRANSLATION_TOKEN, FILEMANAGER_TREE_NAME, FileComponent, FileManagerActionTypes, FileManagerApiService, FileManagerBackendApiService, FileManagerComponent, FileManagerConfiguration, FileManagerEffectsService, FileManagerModule, FileManagerUploader, FileTypeFilterComponent, FileTypeFilterService, FilemanagerNotifications, FilesListComponent, IUploadItemEvent, IUrlConfiguration, ImageDataConverter, InverseFilesSelectionAction, LoadFilesAction, LoadFilesSuccessAction, MoveFilesErrorAction, MoveFilesSuccessAction, PreviewComponent, SearchFileComponent, SearchFilterService, SelectAllFilesAction, SelectFileAction, SelectionComponent, ToolbarComponent, ToolbarEventModel, TreeService, UnSelectAllFilesAction, UnSelectFileAction, UploadFilesAction, UploadFilesErrorAction, UploadFilesSuccessAction, fileManagerReducer, filemanagerStateSelector, getAll, isChangeStateFiles, isChangeStateSelectedFiles };
//# sourceMappingURL=rign-angular2-filemanager.js.map
