import { EventEmitter } from '@angular/core';
import { IFileModel } from '../interface/IFileModel';
import { FileManagerConfiguration } from '../../configuration/fileManagerConfiguration.service';
import { Store } from '@ngrx/store';
import { IFileManagerState } from '../../store/file-manager.reducer';
import { IFilemanagerTranslation } from '../../interfaces/filemanager-translation.interface';
export declare class FileComponent {
    configuration: FileManagerConfiguration;
    private store;
    filemanagerTranslations: IFilemanagerTranslation;
    file: IFileModel;
    onPreviewFile: EventEmitter<any>;
    onCropFile: EventEmitter<any>;
    onSelectFile: EventEmitter<any>;
    constructor(configuration: FileManagerConfiguration, store: Store<IFileManagerState>, filemanagerTranslations: IFilemanagerTranslation);
    /**
     * Fired when clicked on button "delete file"
     */
    deleteFile($event: MouseEvent, file: IFileModel): void;
    getRemoveMessage(file: IFileModel): string;
    openPreview($event: MouseEvent): void;
    openCrop($event: MouseEvent): void;
    selectFile(): void;
    unSelectFile(): void;
    chooseFile($event: MouseEvent, file: IFileModel): void;
}
