import { EventEmitter } from '@angular/core';
import { FileModel } from './file.model';
import { IFileEvent } from './interface/IFileEvent';
import { IFileModel } from './interface/IFileModel';
import { FileManagerConfiguration } from '../configuration/fileManagerConfiguration.service';
import { Store } from '@ngrx/store';
import { IFileManagerState } from '../store/file-manager.reducer';
export declare class FilesListComponent {
    configuration: FileManagerConfiguration;
    private store;
    files: FileModel[];
    selectedFiles: string[];
    onPreviewFile: EventEmitter<any>;
    onCropFile: EventEmitter<any>;
    onSelectFile: EventEmitter<any>;
    removeTitle: string;
    dragZone: string;
    constructor(configuration: FileManagerConfiguration, store: Store<IFileManagerState>);
    /**
     * Fired when clicked on button "delete file"
     */
    deleteFile(file: IFileModel): void;
    openPreview(fileEvent: IFileEvent): void;
    openCrop(fileEvent: IFileEvent): void;
    toggleSelection(file: IFileModel): void;
    isSelected(file: FileModel): boolean;
}
