import { IOuterNode } from '@rign/angular2-tree';
import { Actions } from '@ngrx/effects';
import { IOuterFile } from '../filesList/interface/IOuterFile';
import { Observable } from 'rxjs';
import { IFileModel } from '../filesList/interface/IFileModel';
import { ICropBounds } from '../crop/ICropBounds';
import { FileManagerApiService } from './fileManagerApi.service';
import { FilemanagerNotifications } from '../services/FilemanagerNotifications';
import { CropFileAction, CropFileErrorAction, CropFileSuccessAction, DeleteFileAction, DeleteFileSuccessAction, DeleteSelectedFilesAction, DeleteSelectedFilesSuccessAction, FileManagerAction, LoadFilesAction, LoadFilesSuccessAction, MoveFilesErrorAction, MoveFilesSuccessAction, UploadFilesAction, UploadFilesErrorAction, UploadFilesSuccessAction } from './file-manager.action';
export declare class FileManagerEffectsService {
    private actions$;
    private filemanagerNotification;
    private fileManagerApiService;
    cropFileSuccess$: Observable<CropFileSuccessAction>;
    deleteFileSuccess$: Observable<DeleteFileSuccessAction>;
    loadFiles$: Observable<void | import("./file-manager.action").ChooseFilesAction | CropFileAction | CropFileErrorAction | CropFileSuccessAction | DeleteFileAction | DeleteFileSuccessAction | DeleteSelectedFilesAction | DeleteSelectedFilesSuccessAction | import("./file-manager.action").InverseFilesSelectionAction | LoadFilesAction | LoadFilesSuccessAction | MoveFilesErrorAction | MoveFilesSuccessAction | import("./file-manager.action").SelectAllFilesAction | import("./file-manager.action").SelectFileAction | import("./file-manager.action").UnSelectAllFilesAction | import("./file-manager.action").UnSelectFileAction | UploadFilesAction | UploadFilesErrorAction | UploadFilesSuccessAction>;
    cropFile$: Observable<CropFileErrorAction | CropFileSuccessAction>;
    deleteFile$: Observable<void | DeleteFileSuccessAction>;
    deleteFilesSelection$: Observable<void | import("./file-manager.action").ChooseFilesAction | CropFileAction | CropFileErrorAction | CropFileSuccessAction | DeleteFileAction | DeleteFileSuccessAction | DeleteSelectedFilesAction | DeleteSelectedFilesSuccessAction | import("./file-manager.action").InverseFilesSelectionAction | LoadFilesAction | LoadFilesSuccessAction | MoveFilesErrorAction | MoveFilesSuccessAction | import("./file-manager.action").SelectAllFilesAction | import("./file-manager.action").SelectFileAction | import("./file-manager.action").UnSelectAllFilesAction | import("./file-manager.action").UnSelectFileAction | UploadFilesAction | UploadFilesErrorAction | UploadFilesSuccessAction>;
    uploadFile$: Observable<UploadFilesSuccessAction>;
    moveFile$: Observable<FileManagerAction>;
    filesMoveSuccess$: Observable<LoadFilesAction>;
    deleteFileSuccessEffect$: Observable<void>;
    uploadError$: Observable<void>;
    constructor(actions$: Actions, filemanagerNotification: FilemanagerNotifications, fileManagerApiService: FileManagerApiService);
    protected cropFile(file: IFileModel, bounds: ICropBounds): Observable<IOuterFile>;
    protected deleteFile(file: IFileModel): Observable<boolean>;
    protected deleteFilesSelection(files: string[]): Observable<boolean>;
    protected loadFiles(folderId: string | null): Observable<IOuterFile[]>;
    protected uploadFile(file: IOuterFile): Observable<IOuterFile>;
    protected moveFiles(files: IOuterFile[], folder?: IOuterNode): Observable<IOuterFile[]>;
    protected onCropFileError(file: IFileModel): void;
    protected onDeleteFileError(file: IFileModel): void;
    protected onDeleteFilesSelectionError(): void;
    protected onLoadFilesError(folderId: string): void;
    protected onMoveFilesSuccess(): void;
    protected onMoveFilesError(): void;
}
