import { EventEmitter, OnDestroy } from '@angular/core';
import { IButton, IButtonData } from '../../dropdown/IButton';
import { ButtonClass } from '../../dropdown/Button.class';
import { CurrentDirectoryFilesService } from '../../services/currentDirectoryFiles.service';
import { FileManagerConfiguration } from '../../configuration/fileManagerConfiguration.service';
import { IFilemanagerTranslation } from '../../interfaces/filemanager-translation.interface';
export declare class SelectionComponent implements OnDestroy {
    configuration: FileManagerConfiguration;
    private currentDirectoryFilesService;
    filemanagerTranslations: IFilemanagerTranslation;
    onMenuButtonClick: EventEmitter<any>;
    selectButtonsList: IButton[];
    selectAllButton: ButtonClass;
    private unselectAllButton;
    private inverseSelectionButton;
    private deleteSelectionButton;
    private chooseSelectionButton;
    private onLoadFilesSubscriber;
    constructor(configuration: FileManagerConfiguration, currentDirectoryFilesService: CurrentDirectoryFilesService, filemanagerTranslations: IFilemanagerTranslation);
    ngOnDestroy(): void;
    /**
     * Initialize listener on load files
     */
    initListenOnLoadFiles(): void;
    onSelectDropdownClick(button: IButtonData): void;
    /**
     * Disable all dropdown buttons and main button
     */
    private disableAllButtons;
    /**
     * Enable all dropdown buttons and main button
     */
    private enableAllButtons;
    /**
     * Create list of buttons
     */
    private createBasicButtons;
    /**
     * Enable only select button
     */
    private enableSelectAllButton;
}
